#include	<stdio.h>

static int c_flag;
static char comment_char;
static int quote_ignore_flag;

main(argc, argv)
int argc;
char **argv;
{
    quote_ignore_flag = 0;

    if (argc == 1) {
	c_flag = 1;
    } else if (argc == 2) {
	if (argv[1][0] == '-' && argv[1][1] != 0) {
	    if (argv[1][1] == '\"') {
		c_flag = 1;
		quote_ignore_flag = 1;
	    } else {
		c_flag = 0;
		comment_char = argv[1][1];
	    }
	} else {
	    usage();
	}
    } else {
	usage();
    }

    decom_main();
    exit(0);
}


decom_main()
{
    int c1, c2;

    while ((c1 = getchar()) != EOF) {
	if (c1 == '\"') {
	    putchar(c1); 
	    double_quote();
	} else if (c1 == '\'') {
	    putchar(c1); 
	    single_quote();
	} else if (!c_flag && c1 == comment_char) {
	    comment_line();
	} else if (c_flag && c1 == '/') {
	    c2 = getchar();
	    if (c2 == '*') {
		comment_region();
	    } else if (c2 == '/') {
		comment_line();
	    } else {
		putchar(c1); 
		ungetc(c2, stdin);
	    }
	} else {
	    putchar(c1); 
	}
    }
}


double_quote()
{
    int c1, c2;

    while ((c1 = getchar()) != EOF) {
	if (c1 == '\n') {
	    putchar(c1);
	} else {
	    if (!quote_ignore_flag) putchar(c1);
	}
	if (c1 == '\\') {
	    c2 = getchar();
	    if (c2 == '\n') {
		putchar(c2);
	    } else {
		if (!quote_ignore_flag) putchar(c2);
	    }
	} else if (c1 == '\"') {
	    if (quote_ignore_flag) putchar(c1);
	    return;
	} 
    }

    if (c1 == EOF) {
	fprintf(stderr, "decom: Error -- double quote not closed\n");
	exit(1);
    }
}


single_quote()
{
    int c1;

    c1 = getchar();

    if (c1 == '\\') {
	putchar(c1);
	c1 = getchar();
    }

    putchar(c1);
    c1 = getchar();
    putchar(c1);
    return;
}


comment_region()
{
    int c1, c2;

    while ((c1 = getchar()) != EOF) {
	switch (c1) {
    case '*':
	    c2 = getchar();
	    if (c2 == '/') {
		return;
	    } else if (c2 == '\n') {
		putchar(c2); 
	    } else {
		ungetc(c2, stdin);
	    }
	    break;
    case '\n':
	    putchar(c1); 
	    break;
    default:
	    break;
	}
    }
    if (c1 == EOF) {
	fprintf(stderr, "decom: Error -- comment not closed\n");
	exit(1);
    }
}


comment_line()
{
    int c1;

    while ((c1 = getchar()) != EOF) {
	if (c1 == '\n') {
	    putchar(c1);
	    return;
	}
    }
}


usage()
{
    fprintf(stderr, "Usage: decom [-X] < source_file");
    fprintf(stderr, "     : X is the character which comment outs one line");
    exit(1);
}
