;; "jupiter" Copyright (C) Kenji KATO (kato@suri.co.jp) 17/Nov/1993 
;;   This software is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY.  No author or distributor accepts responsibility
;; to anyone for the consequences of using it or for whether it serves
;; any particular purpose or works at all, unless he says so in writing.
;; Refer to the GNU Emacs General Public License for full details.
;;   Everyone is granted permission to copy, modify and redistribute this
;; software, but only under the conditions described in the GNU Emacs
;; General Public License.  A copy of this license is supposed to have
;; been given to you along with this software so you can know your rights
;; and responsibilities.  It should be in a file named COPYING. If not,
;; write to the Free Software Foundation, 675 Mass Ave, Cambridge, MA
;; 02139, USA.  Among other things, the copyright notice and this notice
;; must be preserved on all copies.

(defvar jupiter:prev-win-conf             nil)
(defvar jupiter:map                       nil)
(defvar jupiter:difference                  0)

(defvar jupiter:local-source-buffer nil)
(defvar jupiter:local-command-number nil)
(defvar jupiter:local-file-name nil)
(defvar jupiter:local-arg nil)
(defvar jupiter:local-win-conf nil)
(defvar jupiter:local-bufname nil)

(if jupiter:map 
    ()
  (setq jupiter:map (make-sparse-keymap))
  (define-key jupiter:map " "     'jupiter:flower-hurricane)
  (define-key jupiter:map "."     'jupiter:goto-line)
  (define-key jupiter:map "n"     'jupiter:next-line)
  (define-key jupiter:map "p"     'jupiter:previous-line)
  (define-key jupiter:map "d"     'jupiter:mark-delete)
  (define-key jupiter:map "k"     'jupiter:mark-kill)
  (define-key jupiter:map "g"     'jupiter:supreme-thunder)
  (define-key jupiter:map "u"     'jupiter:delete-mark)
  (define-key jupiter:map "x"     'jupiter:sparkling-wide-pressure)
  (define-key jupiter:map "w"     'jupiter:copy-line-as-kill)
  (define-key jupiter:map "W"     'jupiter:copy-region-as-kill)
  (define-key jupiter:map "q"     'jupiter:quit)
  (define-key jupiter:map "h"     'jupiter:help))

(defun jupiter:mode-help ()
  "Jupiter⡼ɤХåեˤƻѤǤ륳ޥɡ\n\
\n\
  .      սإ\n\
  SPACE  սإפ塢Хåե\n\
  n      սإפ塢Хåե\n\
  p      սإפ塢Хåե\n\
  d      ȹԤκ\n\
  k      λȹԤޤǤΰκ\n\
  u      \n\
  x      ¹\n\
  w      ȹԤΥ󥰥Хåեؤε\n\
  W      λȹԤޤǤΰΥ󥰥Хåեؤε\n\
  g      ɽ\n\
  h      إץåɽ\n\
  q      λ")


(defun jupiter (&optional num arg)
  (interactive)
  (let ((str   (jupiter:current))
	(buf   (current-buffer))
	(fname (buffer-file-name))
	bufname wconf)
    (setq jupiter:prev-win-conf (current-window-configuration))
    (if num
	()
      (delete-other-windows)
      (split-window)
      (other-window 1)
      (switch-to-buffer (get-buffer-create (jupiter:satellite 0)))
      (erase-buffer)
      (insert-file jupiter:menu)
      (setq num (string-to-int (completing-read "which? " "")))
      (while (= num 0)
	(setq num (string-to-int (completing-read "which? " "")))))
    (jupiter:kill-buffer (jupiter:satellite 0))
    (if (= num 5)
	(progn
	  (set-window-configuration jupiter:prev-win-conf)
	  (amalthea))
      (if arg
	  ()
	(setq arg "")
	(if (>= num 3)
	    (while (string= arg "")
	      (setq arg 
		    (read-from-minibuffer
		     (concat "default \"" str "\": ")))
	      (if (string= arg "") (setq arg str)))))
      (setq bufname (jupiter:satellite num))
      (switch-to-buffer (get-buffer-create bufname))
      (delete-other-windows)
      (split-window (get-buffer-window (current-buffer)) 8)
      (other-window 1)
      (switch-to-buffer buf)
      (other-window 1)
      (setq wconf (current-window-configuration))
;      (make-local-variable 'jupiter:local-source-buffer)
;      (make-local-variable 'jupiter:local-command-number)
;      (make-local-variable 'jupiter:local-file-name)
;      (make-local-variable 'jupiter:local-arg)
;      (make-local-variable 'jupiter:local-win-conf)
;      (make-local-variable 'jupiter:local-bufname)
      (setq jupiter:local-arg arg)
      (setq jupiter:local-command-number (int-to-string num))
      (setq jupiter:local-file-name fname)
      (setq jupiter:local-source-buffer buf)
      (setq jupiter:local-win-conf wconf)
      (setq jupiter:local-bufname bufname)
      (setq buffer-read-only nil)
      (erase-buffer)
      (set-buffer jupiter:local-source-buffer)
      (call-process-region (point-min) (point-max)
			   jupiter:command 
			   nil
			   (get-buffer bufname)
			   nil
			   (int-to-string num)
			   (jupiter:file-extension fname)
			   arg)
      (set-buffer (get-buffer bufname))
      (use-local-map jupiter:map)
      (setq mode-name "Jupiter")
      (setq major-mode 'jupiter:mode-help)
      (goto-line 2)
      (setq buffer-read-only t)
      (set-window-configuration wconf))))


(defun jupiter:satellite (i)
  (cond
   ((= i -1) "*Voyger*")        ((= i  0) "*Galileo*")
   ((= i  1) "*Io*")            ((= i  2) "*Europa*")
   ((= i  3) "*Ganymede*")      ((= i  4) "*Callisto*")
   ((= i  5) "*Amalthea*")      ((= i  6) "*Himalia*")
   ((= i  7) "*Elara*")         ((= i  8) "*Pasiphae*")
   ((= i  9) "*Sinope*")        ((= i 10) "*Lysithea*")
   ((= i 11) "*Carme*")         ((= i 12) "*Ananke*")
   ((= i 13) "*Leda*")          ((= i 14) "*Thebe*")
   ((= i 15) "*Adrastea*")      ((= i 16) "*Metis*")
   (t        (concat "*Jupiter-" (int-to-string i) "*"))))


(defun jupiter:help () 
  (interactive)
  (with-output-to-temp-buffer "*Help*"
    (princ (jupiter:mode-help))
    (print-help-return-message)))
  

(defun jupiter:goto-line ()
  (interactive)
  (if (not (buffer-name jupiter:local-source-buffer))
      (error "source buffer no longer exists!"))
  (set-window-configuration jupiter:local-win-conf)
  (let (tp lnum ch)
    (beginning-of-line)
    (setq ch (char-after (point)))
    (if (or (= ch 68) (= ch 75)) (forward-char))
    (setq tp (point))
    (while (not (= (char-after (point)) 58)) (forward-char))
    (setq lnum (string-to-int (buffer-substring tp (point))))
    (beginning-of-line)
    (other-window 1)
    (goto-line lnum)))


(defun jupiter:flower-hurricane ()
  (interactive)
  (if (or (eobp) (bobp))
      (beep)
    (jupiter:goto-line)
    (Io:where)
    (sit-for 1)
    (other-window 1)))


(defun jupiter:previous-line ()
  (interactive)
  (if (bobp) (goto-char (point-max)))
  (forward-line -1)
  (jupiter:flower-hurricane))


(defun jupiter:next-line ()
  (interactive)
  (if (eobp) (goto-char (point-min)))
  (forward-line 1)
  (jupiter:flower-hurricane))
  

(defun jupiter:quit ()
  (interactive)
  (jupiter:kill-buffer jupiter:local-bufname)
  (set-window-configuration jupiter:prev-win-conf))


(defun jupiter:kill-buffer (string)
  (let ((tb (get-buffer string)))
    (if (and tb (bufferp tb)) (kill-buffer tb))))


(defun jupiter:current () 
  (save-excursion
    (while (and (not (bolp)) 
		(not (jupiter:tokenp)))
      (backward-char))
    (while (and (not (bolp))
		(jupiter:tokenp))
      (backward-char))
    (while (and (not (eolp))
		(not (jupiter:tokenp))) 
      (forward-char))
    (let ((tp (point)))
      (while (and (not (eolp))
		  (jupiter:tokenp))
	(forward-char))
      (buffer-substring tp (point)))))


(defun jupiter:file-extension (fname)
  (if (not fname)
      "c"
    (let ((tmpstr fname)
	  (index 0)
	  i)
      (while (setq i (string-match "/" tmpstr))
	(setq index (1+ (+ index i)))
	(setq tmpstr (substring tmpstr (1+ i))))
      (setq i (string-match "\\." tmpstr))
      (if (not i)
	  "MAKOCHAN"
	(while (setq i (string-match "\\." tmpstr))
	  (setq index (1+ (+ index i)))
	  (setq tmpstr (substring tmpstr (1+ i))))
	tmpstr))))


(defun jupiter:tokenp ()
  (if (eobp) 
      nil
    (let ((ch (char-after (point))))
      (if (string= mode-name "Emacs-Lisp")
	  (cond
	   ((and (>= ch 33) (<= ch  38)))
	   ((and (>= ch 42) (<= ch  45)))
	   ((and (>= ch 47) (<= ch  58)))
	   ((and (>= ch 60) (<= ch  62)))
	   ((and (>= ch 64) (<= ch  90)))
	   ((= ch 92))                   
	   ((and (>= ch 94) (<= ch 126)))
	   (t nil))
	(cond 
	 ((and (>= ch 48) (<= ch  57)))
	 ((and (>= ch 65) (<= ch  90)))
	 ((= ch 95))
	 ((and (>= ch 97) (<= ch 122)))
	 (t nil))))))


(defun jupiter:mark-delete ()
  (interactive)
  (beginning-of-line)
  (if (or (eobp)
	  (bobp)
	  (= (char-after (point)) 68))
      ()
    (setq buffer-read-only nil)
    (if (= (char-after (point)) 75) (delete-char 2))
    (insert "D ")
    (setq buffer-read-only t)
    (beginning-of-line))
  (if (not (eobp)) (forward-line 1)))


(defun jupiter:mark-kill ()
  (interactive)
  (beginning-of-line)
  (if (or (eobp)
	  (bobp)
	  (= (char-after (point)) 75))
      ()
    (setq buffer-read-only nil)
    (if (= (char-after (point)) 68) (delete-char 2))
    (insert "K ")
    (setq buffer-read-only t)
    (beginning-of-line))
  (if (not (eobp)) (forward-line 1)))


(defun jupiter:delete-mark ()
  (interactive)
  (beginning-of-line)
  (if (eobp)
      ()
    (let ((ch (char-after (point))))
      (if (or (bobp)
	      (and (not (= ch 75))
		   (not (= ch 68))))
	  ()
	(setq buffer-read-only nil)
	(delete-char 2)
	(setq buffer-read-only t)))))


(defun jupiter:sparkling-wide-pressure ()
  (interactive)
  (delete-other-windows)
  (let (ch tp line
	(buf jupiter:local-bufname)
	(wconf jupiter:local-win-conf))
    (set-buffer (get-buffer-create (jupiter:satellite -1)))
    (erase-buffer)
    (set-buffer (get-buffer buf))
    (goto-line 2)
    (while (not (eobp))
      (setq ch (char-after (point)))
      (if (not (or (= ch 68) (= ch 75)))
	  (forward-line 1)
	(setq tp (point))
	(forward-line 1)
	(setq line (buffer-substring tp (point)))
	(set-buffer (get-buffer (jupiter:satellite -1)))
	(insert line))
      (set-buffer (get-buffer buf)))
    (switch-to-buffer (get-buffer (jupiter:satellite -1)))
    (if (y-or-n-p "Do you really want to delete these region?")
	(progn
	  (set-buffer (get-buffer buf))
	  (jupiter:delete))
      (message "not deleted"))
    (jupiter:kill-buffer (jupiter:satellite -1))
    (set-window-configuration wconf)))


(defun jupiter:copy-line-as-kill ()
  (interactive)
  (let (tp
	(wconf (current-window-configuration)))
    (if (or (eobp) (bobp))
	(beep)
      (jupiter:goto-line)
      (setq tp (point))
      (end-of-line)
      (forward-char)
      (copy-region-as-kill tp (point))
      (message (buffer-substring tp (point)))
      (other-window 1))
    (set-window-configuration wconf)))


(defun jupiter:copy-region-as-kill ()
  (interactive)
  (beginning-of-line)
  (let (tp tp1 tp2 lnum1 lnum2
	(wconf (current-window-configuration)))
    (if (or (eobp) (bobp))
	(beep)
      (save-excursion
	(setq tp (point))
	(while (not (= (char-after (point)) 58)) (forward-char))
	(setq lnum1 (buffer-substring tp (point)))
	(save-excursion
	  (jupiter:goto-line)
	  (setq tp1 (point)))
	(forward-line 1)
	(setq tp (point))
	(if (eobp)
	    (progn
	      (setq lnum2 "END")
	      (set-buffer jupiter:local-source-buffer)
	      (setq tp2 (point-max)))
	  (while (not (= (char-after (point)) 58)) (forward-char))
	  (setq lnum2 (buffer-substring tp (point)))
	  (jupiter:goto-line)
	  (setq tp2 (point)))
	(copy-region-as-kill tp1 tp2)
	(message (concat lnum1 "--" lnum2))))
    (set-window-configuration wconf)))



(defun jupiter:supreme-thunder ()
  (interactive)
  (let ((bufname jupiter:local-bufname)
	(cnum    jupiter:local-command-number)
	(ext     (jupiter:file-extension jupiter:local-file-name))
	(arg     jupiter:local-arg))
    (setq buffer-read-only nil)  
    (erase-buffer)
    (set-buffer jupiter:local-source-buffer)
    (call-process-region (point-min) (point-max)
			 jupiter:command 
			 nil
			 (get-buffer bufname)
			 nil
			 cnum
			 ext
			 arg)
    (set-buffer (get-buffer bufname))
    (goto-line 2)
    (if (string= cnum "1") (Io:refresh))
    (setq buffer-read-only t)
    (set-window-configuration jupiter:local-win-conf)))


(defun jupiter:delete ()
  (goto-line 2)
  (setq jupiter:difference 0)
  (let (ch tp)
    (while (not (eobp))
      (setq ch (char-after (point)))
      (if (= ch 68) (jupiter:delete-line jupiter:local-bufname))
      (if (= ch 75) (jupiter:delete-region jupiter:local-bufname))
      (forward-line 1)))
  (jupiter:supreme-thunder))


(defun jupiter:delete-line (buf)
  (forward-char 1)
  (let (lnum (tp (point)))
    (while (not (= (char-after (point)) 58)) (forward-char))
    (setq lnum (string-to-int (buffer-substring tp (point))))
    (set-buffer jupiter:local-source-buffer)
    (goto-line (- lnum jupiter:difference))
    (setq tp (point))
    (forward-line 1)
    (delete-region tp (point))
    (set-buffer (get-buffer buf))
    (setq jupiter:difference 
	  (1+ jupiter:difference))))


(defun jupiter:delete-region (buf)
  (forward-char 1)
  (let (lnum1 lnum2 tp ch)
    (setq tp (point))
    (while (not (= (char-after (point)) 58)) (forward-char))
    (setq lnum1 (string-to-int (buffer-substring tp (point))))
    (forward-line 1)
    (if (eobp)
	(setq lnum2 -1)
      (setq ch (char-after (point)))
      (if (or (= ch 68) (= ch 75)) (forward-char))
      (setq tp (point))
      (while (not (= (char-after (point)) 58)) (forward-char))
      (setq lnum2 (string-to-int (buffer-substring tp (point)))))
    (forward-line -1)
    (set-buffer jupiter:local-source-buffer)
    (goto-line (- lnum1 jupiter:difference))
    (setq tp (point))
    (if (< lnum2 0)
	(goto-char (point-max))
      (goto-line (- lnum2 jupiter:difference)))
    (delete-region tp (point))
    (set-buffer (get-buffer buf))
    (setq jupiter:difference 
	  (+ jupiter:difference (- lnum2 lnum1)))))


(defun Io:refresh ()
  (let ((tp (point)) lnum)
    (while (not (or (eolp) (= (char-after (point)) 58)))
      (forward-char))
    (setq lnum (string-to-int (buffer-substring tp (point))))
    (if (and (= lnum 0) (not (eobp)))
	(Io:auto-repair)))
  (goto-line 2))


(defun Io:auto-repair ()
  (message "Io: auto-repairing...")
  (let ((lnum 0) newfnum newlnum tp ch)
    (while (= lnum 0)
      (forward-char)
      (setq tp (point))
      (end-of-line)
      (backward-char)
      (setq ch (char-after (point)))
      (while (and (>= ch 48) (<= ch  57))
	(backward-char)
	(setq ch (char-after (point))))
      (forward-char)
      (setq newfnum (buffer-substring tp (point)))
      (setq tp (point))
      (end-of-line)
      (setq newlnum (buffer-substring tp (point)))
      (beginning-of-line)
      (setq tp (point))
      (forward-line 1)
      (delete-region tp (point))
      (Io:insert (string-to-int newlnum) newfnum)
      (if (eobp)
	  (setq lnum -1)
	(while (not (or (= (char-after (point)) 58) (eolp)))
	  (forward-char))
	(setq lnum (string-to-int (buffer-substring tp (point))))))
    (goto-line 2))
  (message "Io: etags output error, repaired automatically"))


(defun Io:insert (lnum fnum)
  (if (= lnum 0)
      (forward-line 1)
    (save-excursion
      (let ((qflag nil)
	    tp num)
	(while (and (not (eobp))
		    (not qflag))
	  (setq tp (point))
	  (while (not (or (= (char-after (point)) 58) (eolp)))
	    (forward-char))
	  (setq num (string-to-int (buffer-substring tp (point))))
	  (if (> num lnum)
	      (progn
		(setq qflag t)
		(beginning-of-line)
		(insert (format "%d:%s\n" lnum newfnum)))
	    (forward-line 1)))
	(if (eobp)
	    (insert (format "%d:%s\n" lnum newfnum)))))))

(defun Io:where ()
  (let ((buf (get-buffer (jupiter:satellite 1)))
	(bname-1 (buffer-name jupiter:local-source-buffer))
	bname-2
	(qflag nil)
	(curlnum (count-lines (point-min) (point)))
	(line nil)
	num tp)
    (save-excursion
      (if (bolp) (setq curlnum (1+ curlnum)))
      (if (not buf)
	  ()
	(set-buffer buf)
	(setq bname-2 (buffer-name jupiter:local-source-buffer))
	(if (not (string= bname-1 bname-2))
	    ()
	  (goto-line 2)
	  (while (and (not (eobp))
		      (not qflag))
	    (setq tp (point))
	    (while (not (or (= (char-after (point)) 58) (eolp)))
	      (forward-char))
	    (setq num (string-to-int (buffer-substring tp (point))))
	    (if (<= num curlnum)
		(forward-line 1)
	      (setq qflag t)
	      (forward-line -1)
	      (if (bobp)
		  (setq line "*Not defined (beginning of buffer)*")
		(setq tp (point))
		(end-of-line)
		(setq line (buffer-substring tp (point))))))
	  (if (eobp)
	      (progn
		(forward-line -1)
		(setq tp (point))
		(end-of-line)
		(setq line (buffer-substring tp (point)))))
	  (message line))))))
  
(defun Io:top-level ()
  (let ((wconf (current-window-configuration)))
    (io)
    (set-window-configuration wconf)))

;;;
;;; Top-level Command
;;;
  
(defun io ()
  (interactive)
  (jupiter 1)
  (setq buffer-read-only nil)
  (Io:refresh)
  (setq buffer-read-only t))

(defun europa ()
  (interactive)
  (Io:top-level)
  (jupiter 2))

(defun ganymede ()
  (interactive)
  (Io:top-level)
  (jupiter 3))

(defun callisto ()
  (interactive)
  (Io:top-level)
  (jupiter 4))

(defun amalthea ()
  (interactive)
  (delete-other-windows)
  (split-window)
  (switch-to-buffer (get-buffer-create (jupiter:satellite 5)))
  (setq buffer-read-only nil)
  (erase-buffer)
  (other-window 1)
  (call-process-region (point-min) (point-max)
		       jupiter:command 
		       nil
		       (get-buffer (jupiter:satellite 5))
		       nil
		       "5"
		       "dummy" "dummy")
  (other-window 1))

(defun where ()
  (interactive)
  (Io:top-level)
  (Io:where))
