;; "mercury ver1.01" Copyright (C) Oct/1995 Kenji KATO (kato@suri.co.jp) 
;;   This software is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY.  No author or distributor accepts responsibility
;; to anyone for the consequences of using it or for whether it serves
;; any particular purpose or works at all, unless he says so in writing.
;; Refer to the GNU Emacs General Public License for full details.
;;   Everyone is granted permission to copy, modify and redistribute this
;; software, but only under the conditions described in the GNU Emacs
;; General Public License.  A copy of this license is supposed to have
;; been given to you along with this software so you can know your rights
;; and responsibilities.  It should be in a file named COPYING.  Among
;; other things, the copyright notice and this notice must be preserved
;; on all copies.

(defvar mercury:mode-map)
(defvar mercury:fname)

(setq mercury:mode-map (make-sparse-keymap))
(define-key mercury:mode-map " " 'mercury:shabon-spray)

(defun mercury (tn tf tl)
  (if (not (file-exists-p tf)) (error "database not exists"))
  (let ((buf (get-buffer-create "*Mercury*")) lnum) 
    (set-buffer buf) (setq buffer-read-only nil) (erase-buffer)
    (call-process mercury:lookup nil "*Mercury*" nil tn 
		  (expand-file-name tf) (int-to-string tl))
    (setq buffer-read-only t) (goto-char (point-min))
    (use-local-map mercury:mode-map) (setq mode-name "Mercury")
    (setq lnum (count-lines (point-min) (point-max)))
    (cond ((= lnum 0) (message "Not found in database") (kill-buffer buf))
	  ((= lnum 1) (mercury:shine-aqua-illusion) (kill-buffer buf))
	  (t (switch-to-buffer buf) (message "searching...done")))))

(defun mercury:shabon-spray () (interactive)
  (if (eobp) (forward-line -1) (beginning-of-line))
  (if (and (> (char-after (point)) 47) (< (char-after (point)) 58))
      (mercury:shine-snow-illusion) (mercury:shine-aqua-illusion)))

(defun mercury:shine-aqua-illusion ()
  (while (not (= (char-after (point)) 9)) (forward-char)) (forward-char)
  (let ((tp (point)) lnum st buf)
    (while (not (= (char-after (point)) 9)) (forward-char))
    (setq mercury:fname (buffer-substring tp (point)))
    (if (file-exists-p mercury:fname) (setq buffer-read-only nil)
      (error (format "cannot open %s" mercury:fname)))
    (forward-char (if (= (char-after (1+ (point))) 47) 2 1))
    (setq tp (point))
    (while (not (eolp))
      (if (= (char-after (point)) 92)
	  (if (= (char-after (1+ (point))) 47) (delete-char 1) (forward-char))
	(if (mercury:metap (char-after (point))) (insert 92)))
      (forward-char))
    (setq buffer-read-only t)
    (if (= (char-after (1- (point))) 47) (backward-char))
    (setq st (buffer-substring tp (point))) (beginning-of-line)
    (if (not (= (string-to-int st) 0))
	(progn (find-file mercury:fname) (goto-line (string-to-int st)))
      (set-buffer (setq buf (get-buffer-create "*Mercury-2*")))
      (setq buffer-read-only nil) (erase-buffer)
      (call-process "grep" nil "*Mercury-2*" nil "-n" st mercury:fname)
      (setq buffer-read-only t) (goto-char (point-min))
      (use-local-map mercury:mode-map) (setq mode-name "mercury")
      (setq lnum (count-lines (point-min) (point-max)))
      (cond ((= lnum 0) (find-file mercury:fname) (kill-buffer buf))
	    ((= lnum 1) (mercury:shine-snow-illusion) (kill-buffer buf))
	    (t (switch-to-buffer buf))))))
  
(defun mercury:shine-snow-illusion ()
  (let ((tp (point)) lnum) (message "searching...done")
    (while (not (= (char-after (point)) 58)) (forward-char))
    (setq lnum (string-to-int (buffer-substring tp (point))))
    (find-file mercury:fname) (goto-line lnum)))

(defun mercury:input () (completing-read "Mercury input: " ""))

(defun mercury:current () 
  (save-excursion
    (while (and (not (bolp)) (mercury:tokenp)) (backward-char))
    (while (and (not (eolp)) (not (mercury:tokenp))) (forward-char))
    (let ((tp (point)))
      (while (and (not (eolp)) (mercury:tokenp)) (forward-char))
      (buffer-substring tp (point)))))

(defun mercury:tokenp ()
  (let ((ch (char-after (point))))
    (cond ((and (>= ch 65) (<= ch 90)))  ((and (>= ch 97) (<= ch 122)))
	  ((and (>= ch 48) (<= ch 57)))  ((= ch 95))      (t nil))))

(defun mercury:metap (ch)
  (cond ((= ch 34)) ((= ch 42)) ((= ch 46)) 
	((= ch 91)) ((= ch 93)) (t nil)))
