;; "venus.el versin 2.0.1" Copyright (C) 1995 Kenji KATO (kato@suri.co.jp)
;; This software is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY.  No author or distributor
;; accepts responsibility to anyone for the consequences of using it
;; or for whether it serves any particular purpose or works at all,
;; unless he says so in writing.  Refer to the GNU Emacs General Public
;; License for full details.
;; Everyone is granted permission to copy, modify and redistribute
;; this software, but only under the conditions described in the
;; GNU Emacs General Public License.   A copy of this license is
;; supposed to have been given to you along with this software so you
;; can know your rights and responsibilities.  It should be in a
;; file named COPYING.  Among other things, the copyright notice
;; and this notice must be preserved on all copies.

(autoload 'shell-mode "shell" nil t)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;  .emacs ٤ѿ

(defvar venus:dir              "~/")
(defvar venus:generate-command "~/bin/gencom")
(defvar venus:remove-command   "~/bin/remcom")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
(defvar venus:previous-buffer   nil)
(defvar venus:top-dir           nil)
(defvar venus:work-buffer       nil)
(defvar venus:prev-win-conf     nil)
(defvar venus:quit-flag         nil)
(defvar venus:leaf-flag         nil)
(defvar venus:file-flag         nil)
(defvar venus:current-file      nil)
(defvar venus:current-directory nil)
(defvar venus:leaf              nil)
(defvar venus:process-name      nil)
(defvar venus:current-process   nil)
(defvar venus:line              nil)
(defvar venus:file              nil)
(defvar venus:wconf-flag        nil)
(defvar venus:force             nil)
(defvar venus:default-directory nil)
(defvar venus:include-list      nil)

(defconst venus:help "\
˥塼Υߥ˥Хåեϥޥɡ\n\
    ˥塼\n\
   n    إ\n\
   p    إ\n\
   /    ȥåץ˥塼\n\
   ..   Υ˥塼\n\
   t    ȥåץǥ쥯ȥѹ\n\
   q    λ\n\
   ;    VENUSե򥪡ץ󤷡λ\n\
   .    ߤΥ˥塼Ĥλ\n\
   .2   ߤΥ˥塼Ĥ̤ʬ䤷λ")
	       
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun venus (&optional dir inlist)
  (interactive) 
  (venus:start dir)
  (venus:love-me-chain inlist)
  (venus:quit))


(defun venus:retry () 
  (let ((top-dir  venus:top-dir)
	(win-conf venus:prev-win-conf))
    (venus:start venus:current-directory)
    (setq venus:prev-win-conf win-conf)
    (setq venus:top-dir top-dir))
  (venus:love-me-chain nil)
  (venus:quit))
    

(defun venus:start (dir)
  (setq venus:default-directory default-directory)
  (setq venus:previous-buffer (current-buffer))
  (setq venus:prev-win-conf (current-window-configuration))
  (setq venus:buffer      (get-buffer-create "*Venus*"))
  (setq venus:work-buffer (get-buffer-create "*Venus:work*"))
  (setq venus:quit-flag 0)
  (setq venus:leaf-flag nil)
  (setq venus:file-flag nil)
  (setq venus:wconf-flag 1)
  (setq venus:line nil)
  (setq venus:file nil)
  (setq venus:force nil)
  (cond
   (dir
    (setq venus:top-dir dir))
   ((file-exists-p (concat default-directory "VENUS"))
    (setq venus:top-dir (substring default-directory
				   0 (1- (length default-directory)))))
   ((and (stringp venus:dir) 
	 (file-directory-p venus:dir)
	 (file-exists-p
	  (concat venus:dir 
		  (if (string= (substring venus:dir (1- (length venus:dir))) "/")
		      "" "/")
		  "VENUS")))
    (setq venus:top-dir venus:dir))
   (t
    (while (not 
	    (file-exists-p
	     (concat 
	      (setq venus:top-dir (call-interactively 'venus:get-dir))
	      "/VENUS"))))))
  (if (not (file-exists-p venus:top-dir))
      (venus:error 
       (format "ȥåץǥ쥯ȥ(%s)ְ꤬äƤޤ" venus:top-dir)
       venus:top-dir))
  (setq venus:current-directory venus:top-dir)
  (setq venus:current-file (concat venus:current-directory "/VENUS"))
  (if (not (file-exists-p venus:current-file))
      (venus:error 
       (format "ȥåץǥ쥯ȥ(%s)VENUSե뤬ޤ" venus:top-dir)
       venus:top-dir))
  (delete-other-windows)
  (set-buffer venus:work-buffer)
  (setq buffer-read-only nil)
  (erase-buffer)
  (buffer-flush-undo venus:work-buffer)
  (switch-to-buffer venus:buffer)
  (setq buffer-read-only nil)
  (erase-buffer)
  (buffer-flush-undo venus:buffer))


(defun venus:love-me-chain (inlist)
  (let ((help-flag nil)
	(scroll-flag nil)
	lnum maxnum ns contents table title tp spec leaf str st1 leaf-title)
    (while (= venus:quit-flag 0)
      (set-buffer venus:work-buffer)
      (if help-flag
	  (setq help-flag nil)
	(delete-other-windows))
      (if scroll-flag
	  (setq scroll-flag nil)
	(insert-file venus:current-file)
	(venus:eval-region "init")
	(venus:get-include-list)
	(venus:insert-current-file)
	(if venus:leaf-flag
	    (progn
	      (if venus:file
		  ()
		(if venus:line
		    (setq leaf venus:line)
		  (setq leaf-title (venus:get-item venus:leaf nil venus:current-file))
		  (setq leaf (venus:cut-region venus:leaf venus:current-file))))
	      (setq maxnum 0)
	      (set-buffer venus:buffer)
	      (erase-buffer)
	      (if leaf-title
		  (progn
		    (insert (format "%s\n\n" leaf-title))
		    (setq leaf-title nil)))
	      (if venus:file
		  (insert-file venus:file)
		(insert leaf))
	      (goto-char (point-min))
	      (set-buffer venus:work-buffer))
	  (setq title (venus:get-item "title" "˥塼" venus:current-file))
	  (setq contents (venus:cut-region "menu" venus:current-file))
	  (setq table (venus:cut-region "table" venus:current-file))
	  (set-buffer venus:buffer)
	  (erase-buffer)
	  (insert " " title " \n\n" contents)
	  (goto-char (point-min))
	  (set-buffer venus:work-buffer)
	  (erase-buffer)
	  (insert table)
	  (untabify (point-min) (point-max))
	  (setq maxnum (count-lines (point-min) (point-max)))))
      (if venus:force
	  (setq inlist (list venus:force)))
      (if (not inlist)
	  (setq ans (completing-read "which? " ""))
	(if (not (listp inlist))
	    (venus:error
	     "venusؿ裳ꥹȤǤޤ"
	     "ե")
	  (setq ans (car inlist))
	  (if (not (stringp ans))
	      (venus:error
	       "venusؿ裳ΥꥹȤǤʸǤޤ"
	       "ե")
	    (setq inlist (cdr inlist)))))
      (setq lnum (string-to-int ans))
      (while (and
	      (not (string= ans ""))
	      (not (string= ans "n"))
	      (not (string= ans "p"))
	      (not (string= ans "q"))
	      (not (string= ans "/"))
	      (not (string= ans "t"))
	      (not (string= ans "."))
	      (not (string= ans ".2"))
	      (not (string= ans ".."))
	      (not (string= ans ";"))
	      (or (<= lnum 0) (> lnum maxnum)))
	(setq ans (completing-read "which? " ""))
	(setq lnum (string-to-int ans)))
      (if (= lnum 0)
	  (progn
	    (cond
	     ((string= ans "")
	      (setq help-flag t)
	      (with-output-to-temp-buffer "*Help*" (princ venus:help)))
	     ((string= ans "n")
	      (setq scroll-flag t)
	      (set-buffer venus:buffer)
	      (delete-other-windows)
	      (forward-line (window-height)))
	     ((string= ans "p")
	      (setq scroll-flag t)
	      (set-buffer venus:buffer)
	      (delete-other-windows)
	      (forward-line (* (window-height) -1)))
	     ((string= ans "q")
	      (setq venus:quit-flag 3))
	     ((string= ans ";")
	      (setq venus:quit-flag 2)
	      (find-file (concat venus:current-directory "/VENUS")))
	     ((string= ans ".2")
	      (setq venus:quit-flag 4))
	     ((string= ans ".")
	      (setq venus:quit-flag 1))
	     ((string= ans "/")
	      (setq venus:file-flag nil)
	      (setq venus:leaf-flag nil)
	      (setq venus:current-directory venus:top-dir)
	      (setq venus:current-file (concat venus:top-dir "/VENUS")))
	     ((string= ans "t")
	      (setq venus:file-flag nil)
	      (setq venus:leaf-flag nil)
	      (while (not 
		      (file-exists-p
		       (concat 
			(setq venus:top-dir (call-interactively 'venus:get-dir))
			"/VENUS"))))
	      (setq venus:current-directory venus:top-dir)
	      (setq venus:current-file (concat venus:top-dir "/VENUS")))
	     ((string= ans "..")
	      (cond
	       (venus:leaf-flag
		(setq venus:leaf-flag nil))
	       (venus:file-flag
		(setq venus:file-flag nil)
		(setq venus:current-file
		      (concat venus:current-directory "/VENUS")))
	       ((string= venus:current-directory venus:top-dir))
	       (t
		(setq venus:current-directory
		      (venus:upper-directory venus:current-directory))
		(setq venus:current-file
		    (concat venus:current-directory "/VENUS"))))))
	    (setq ans nil))
	(setq ans nil)
	(goto-line lnum)
	(while (= (char-after (point)) 32) (forward-char))
	(if (eolp)
	    (venus:error
	     (format "%dܤ˶Ԥޤ" lnum)
	     venus:current-file))
	(while (and (not (= (char-after (point)) 32))
		    (not (eolp)))
	  (forward-char))
	(while (= (char-after (point)) 32) (forward-char))
	(if (eolp)
	    (venus:error
	     (format "%dܤλ(%s %s)ŬڤǤ" lnum spec str)
	     venus:current-file))
	(setq tp (point))
	(while (and (not (= (char-after (point)) 32))
		    (not (eolp)))
	  (forward-char))
	(setq spec (buffer-substring tp (point)))
	(while (= (char-after (point)) 32) (forward-char))
	(setq tp (point))
	(end-of-line)
	(while (= (char-after (1- (point))) 32) (backward-char))
	(setq str (buffer-substring tp (point)))
	(if (or (string= spec "") (>= tp (point)))
	    (venus:error
	     (format "%dܤλ(%s %s)ŬڤǤ" lnum spec str)
	     venus:current-file))
	(setq st1 (substring spec 0 1))
	(setq venus:line         nil)
	(setq venus:file         nil)
	(setq venus:force        nil)
	(setq venus:wconf-flag    1)
	(cond
	 ((string= st1 "D")
	  (venus:lower-directory str))
	 ((string= st1 "F")
	  (venus:select-file str))
	 ((string= st1 "V")
	  (venus:mina str))
	 ((string= st1 "Q")
	  (venus:usagi str))
	 ((string= st1 "I")
	  (venus:insert spec str))
	 ((string= st1 "O")
	  (venus:open-file spec str))
	 ((string= st1 "E")
	  (venus:eval-program spec str))
	 ((string= st1 "C")
	  (venus:crescent-beam spec str))
	 ((string= st1 "P")
	  (venus:start-process spec str))
	 ((string= st1 "S")
	  (venus:start-shell spec str))
	 (t
	  (venus:error
	   (format "Ŭڤʻ(%s %s)Ƥޤ" spec str)
	   venus:current-file)))
	))))


(defun venus:get-first-arg (str)
  (let ((i (string-match " " str)))
    (if (not i)
	str
      (substring str 0 i))))

(defun venus:get-second-arg (str)
  (let ((tmpstr str) 
	(i (string-match " " str)))
    (if (not i)
	nil
      (setq tmpstr (substring tmpstr (1+ i)))
      (setq i (string-match "[^ ]" tmpstr))
      (venus:get-first-arg (substring tmpstr i)))))

(defun venus:upper-directory (dir)
  (let ((tmpstr dir)
	(index 0)
	i)
    (while (setq i (string-match "/" tmpstr))
      (setq index (1+ (+ index i)))
      (setq tmpstr (substring tmpstr (1+ i))))
    (substring dir 0 (1- index))))


(defun venus:get-include-list ()
  (let ((include-files (venus:cut-region "include"))
	(cbuf (current-buffer))
	(bufname "*venus:work-include*")
	tp fname)
    (if (or (not include-files) (string= include-files ""))
	(setq venus:include-list nil)
      (set-buffer (get-buffer-create bufname))
      (erase-buffer)
      (insert include-files)
      (goto-char (point-min))
      (untabify (point-min) (point-max))
      (replace-string " " "")
      (goto-char (point-min))
      (setq venus:include-list nil)
      (while (not (eobp))
	(setq tp (point))
	(end-of-line)
	(setq fname (buffer-substring tp (point)))
	(setq fname (concat venus:current-directory "/" fname))
	(if (not (file-exists-p fname))
	    (venus:error 
	     (format "includeΰ˻ꤵ줿%sե뤬ޤ" fname)
	     venus:current-file))
	(setq venus:include-list (cons fname venus:include-list))
	(forward-line 1))
      (kill-buffer (get-buffer bufname))
      (set-buffer cbuf))))


(defun venus:cut-region (string &optional file)
  (save-excursion
    (goto-char (point-min))
    (let ((bst (concat "@begin{" string "}"))
	  (est (concat "@end{" string "}"))
	  tp
	  retstr)
      (if (not (search-forward bst nil t))
	  (if file (venus:error (format "%sޤ" bst) file))
	(forward-line 1)
	(setq tp (point))
	(if (not (search-forward est nil t))
	    (venus:error 
	     (format "%sޤ" est)
	     (if file file venus:current-file))
	  (beginning-of-line)
	  (setq retstr (buffer-substring tp (point)))
	  (forward-line 1)))
      retstr)))
  

(defun venus:eval-region (string &optional file)
  (save-excursion
    (goto-char (point-min))
    (let ((bst (concat "@begin{" string "}"))
	  (est (concat "@end{" string "}"))
	  tp)
      (if (not (search-forward bst nil t))
	  (if file (venus:error (format "%sޤ" bst) file))
	(forward-line 1)
	(setq tp (point))
	(if (not (search-forward est nil t))
	    (venus:error 
	     (format "%sޤ" est)
	     (if file file venus:current-file))
	  (beginning-of-line)
	  (eval-region tp (point)))))))

  
(defun venus:get-item (item default file)
  (save-excursion
    (goto-char (point-min))
    (if (search-forward (concat "@" item "{") nil t)
	(let ((tp (point)) ep)
	  (end-of-line)
	  (setq ep (point))
	  (goto-char tp)
	  (if (search-forward "}" ep t)
	      (if (= tp (1- (point)))
		  default
		(buffer-substring tp (1- (point))))
	    (venus:error (format "@%s } Ĥޤ" item)
			 file)))
      default)))


(defun venus:quit ()
  (venus:kill-buffer venus:work-buffer)
  (cond
   ; 1. ⤻λ
   ((= venus:quit-flag 1))
   ; 2. ʥХåե򻦤λ
   ((= venus:quit-flag 2)
    (venus:kill-buffer venus:buffer))
   ((= venus:quit-flag 3)
   ; 3. ̤򸵤ξ֤ᤷλ
    (venus:kill-buffer venus:buffer)
    (set-window-configuration venus:prev-win-conf))
   ; 4. β̤ȥʥХåե򣲤ɽλ
   ((= venus:quit-flag 4)
    (set-window-configuration venus:prev-win-conf)
    (delete-other-windows)
    (split-window)
    (switch-to-buffer venus:buffer))))


(defun venus:kill-buffer (buffer)
  (if (and buffer (bufferp buffer))
      (kill-buffer buffer)
    (if (and (stringp buffer) (get-buffer buffer))
	(kill-buffer (get-buffer buffer)))))

(defun venus:insert-current-file ()
  (let ((tlist venus:include-list))
    (erase-buffer)
    (insert-file venus:current-file)
    (goto-char (point-max))
    (while tlist
      (insert-file (car tlist))
      (goto-char (point-max))
      (setq tlist (cdr tlist)))))

(defun venus:get-dir (dir)
  (interactive "DDirectory: ")
  (if (string= (substring dir (1- (length dir))) "/")
      (substring dir 0 (1- (length dir)))
    dir))

(defun venus:make-temp-command (str &optional line-flag)
  (let (outbuf program cfile)
    (setq outbuf (get-buffer-create "*Venus:temporary*"))
    (set-buffer outbuf)
    (erase-buffer)
    (set-buffer venus:work-buffer)
    (erase-buffer)
    (if line-flag
	(insert str "\n")
      (venus:insert-current-file)
      (setq program (venus:cut-region str venus:current-file))
      (erase-buffer)
      (insert program))
    (call-process-region (point-min) (point-max) 
			 venus:generate-command nil outbuf)
    (set-buffer outbuf)
    (goto-char (point-min))
    (end-of-line)
    (setq cfile (buffer-substring (point-min) (point)))
    (if (not (file-exists-p cfile))
	(venus:error
	 (format "ޥɥե(%s)κ˼Ԥޤ"
		 cfile)
	 cfile))
    (kill-buffer outbuf)
    cfile))

(defun venus:error (fmt file)
  (venus:kill-buffer venus:buffer)
  (delete-other-windows)
  (let ((buf (get-buffer-create "*Venus:error*")))
    (switch-to-buffer buf)
    (setq buffer-read-only nil)
    (buffer-flush-undo buf)
    (erase-buffer)
    (insert (format "ե롧%s\n\n" file) fmt)
    (fill-region (point-min) (point-max))
    (goto-line (point-min))
    (error "error")))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;  feature "D"

(defun venus:lower-directory (str)
  (if venus:file-flag
      (venus:error
       (format "VENUSեʳ(%s)ϥǥ쥯ȥ(%s)Ǥޤ"
	       venus:current-file str)
       venus:current-file)
    (setq venus:current-directory
	  (concat venus:current-directory "/" str))
    (if (not (file-directory-p venus:current-directory))
	(venus:error
	 (format "%sǻꤵƤǥ쥯ȥ(%s)¸ߤޤ"
		 venus:current-file str)
	 venus:current-file))
    (setq venus:current-file
	  (concat venus:current-directory "/VENUS"))
    (if (not (file-exists-p venus:current-file))
	(venus:error
	 (format "ǥ쥯ȥ%sVENUSե뤬¸ߤޤ"
		 venus:current-directory)
	 venus:current-file))
    (setq venus:leaf-flag nil)
    (setq venus:file-flag nil)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;  feature "F"

(defun venus:select-file (str)
  (if venus:file-flag
      (venus:error
       (format "VENUSեʳ(%s)ϥե(%s)Ǥޤ"
	       venus:current-file str)
       venus:current-file)
    (setq venus:current-file
	  (concat venus:current-directory "/" str))
    (if (not (file-exists-p venus:current-file))
	(venus:error
	 (format "ǥ쥯ȥ%s%sե뤬¸ߤޤ"
		 venus:current-directory str)
	 venus:current-file))
    (setq venus:leaf-flag nil)
    (setq venus:file-flag t)))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;  feature "I"

(defun venus:insert (spec str)
  (setq venus:leaf-flag t)
  (setq venus:leaf str)
  (let ((len (length spec))
	(num 1)
	(wconf-flag 1)
	st)
    (while (< num len)
      (setq st (substring spec num (1+ num)))
      (cond
       ((string= st "i")
	(setq venus:line str))
       ((string= st "q")
	(setq venus:force "."))
       ((string= st "2")
	(setq venus:force ".2"))
       ((string= st "f")
	(setq venus:file (concat venus:current-directory "/" str))
	(if (not (file-exists-p venus:file))
	    (venus:error
	     (format "ե %s ¸ߤޤ" str)
	     venus:current-file)))
       (t
	(venus:error
	       (format "Ŭڤʻ(%s %s)Ƥޤ" spec str)
	       venus:current-file)))
      (setq num (1+ num)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;  feature "O"

(defun venus:open-file (spec str)
  (let ((len (length spec))
	(num 1)
	(wconf-flag 1)
	(search-flag nil)
	(goto-flag nil)
	(hit-flag nil)
	(fname (concat venus:current-directory "/" 
		       (venus:get-first-arg str)))
	st buf wconf)
    (if (not (file-exists-p fname))
	(venus:error
	       (format "ե %s ¸ߤޤ" fname)
	       venus:current-file))
    (while (< num len)
      (setq st (substring spec num (1+ num)))
      (cond
       ((string= st "h")
	(setq hit-flag t))
       ((string= st "s")
	(setq search-flag t))
       ((string= st "g")
	(setq goto-flag t))
       ((string= st "d")
	(setq wconf-flag 0))
       ((string= st "2")
	(setq wconf-flag 2))
       (t
	(venus:error
	       (format "Ŭڤʻ(%s %s)Ƥޤ" spec fname)
	       venus:current-file)))
      (setq num (1+ num)))
    (setq wconf (current-window-configuration))
    (find-file fname)
    (goto-char (point-min))
    (if goto-flag
	(goto-line (string-to-int (venus:get-second-arg str)))
      (if search-flag
	  (search-forward (venus:get-second-arg str) nil t)))
    (if hit-flag
	(progn
	  (completing-read "Hit return key: " "")
	  (cond
	   ((= wconf-flag 0)
	    (kill-buffer (current-buffer))
	    (set-window-configuration wconf))
	   (t
	    (set-window-configuration wconf))))
      (setq venus:quit-flag 2)
      (if (= wconf-flag 2)
	  (progn
	    (setq buf (current-buffer))
	    (set-window-configuration venus:prev-win-conf)
	    (delete-other-windows)
	    (split-window)
	    (switch-to-buffer buf))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;  feature "E"

(defun venus:eval-program (spec str)
  (let ((len (length spec))
	(num 1)
	(line-flag nil)
	(buffer-flag 1)
	(return-flag 0)
	st wconf program second fname bufname)
    (while (< num len)
      (setq st (substring spec num (1+ num)))
      (cond
       ((string= st "r")
	(setq return-flag 1))
       ((string= st "h")
	(setq return-flag 2))
       ((string= st "i")
	(setq line-flag t))
       ((string= st "R")
	(setq buffer-flag 2))
       ((string= st "F")
	(setq buffer-flag 3)
	(setq fname (concat venus:current-directory "/"
			    (venus:get-second-arg str)))
	(if (not (file-exists-p fname))
	    (venus:error
	     (format "%sե뤬ޤ" fname)
	     venus:current-file)))
       (t
	(venus:error
	       (format "Ŭڤʻ(%s %s)Ƥޤ" spec str)
	       venus:current-file)))
      (setq num (1+ num)))
    (erase-buffer)
    (if line-flag
	(progn
	  (if (or (= buffer-flag 2) (= buffer-flag 3))
	      (venus:error
	       (format "iץR,FץƱ˻Ǥޤ")
	       venus:current-file))
	  (insert "(defun venus:current-function () " str ")"))
      (venus:insert-current-file)
      (setq program (venus:cut-region (venus:get-first-arg str)
				      venus:current-file))
      (if (= buffer-flag 2)
	  (setq second (venus:cut-region 
			(venus:get-second-arg str)
			venus:current-file)))
      (erase-buffer)
      (insert "(defun venus:current-function ()" program ")"))
    (eval-current-buffer)
    (setq wconf (current-window-configuration))
    (if (= buffer-flag 1)
	(set-window-configuration venus:prev-win-conf)
      (setq bufname (concat "*Venus:elisp:" (venus:get-first-arg str) "*"))
      (switch-to-buffer (get-buffer-create bufname))
      (setq buffer-read-only nil)
      (erase-buffer)
      (if (= buffer-flag 2)
	  (insert second)
	(insert-file fname))
      (goto-char (point-min))
      (setq venus:prev-win-conf (current-window-configuration)))
    (venus:current-function)
    (cond
     ((= return-flag 1)
      (set-window-configuration wconf))
     ((= return-flag 2)
      (completing-read "Hit return key: " "")
      (set-window-configuration wconf))
     (t
      (setq venus:quit-flag 2)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;  feature "C"

(defun venus:crescent-beam (spec str)
  (let ((len (length spec))
	(num 1)
	(line-flag nil)
	(stdin-flag 0)
	(return-flag 0)
	(wconf-flag 1)
	(cb-comfile nil)
	outbuf tp st wconf program fname second)
    (while (< num len)
      (setq st (substring spec num (1+ num)))
      (cond
       ((string= st "r")
	(setq return-flag 1))
       ((string= st "h")
	(setq return-flag 2))
       ((string= st "i")
	(setq line-flag t))
       ((string= st "S")
	(setq stdin-flag 1))
       ((string= st "R")
	(setq stdin-flag 2)
	(venus:insert-current-file)
	(setq second (venus:cut-region 
		      (venus:get-second-arg str)
		      venus:current-file)))
       ((string= st "F")
	(setq stdin-flag 3)
	(setq fname (concat venus:current-directory "/"
			    (venus:get-second-arg str)))
	(if (not (file-exists-p fname))
	    (venus:error
	     (format "%sե뤬ޤ" fname)
	     venus:current-file)))
       ((string= st "d")
	(setq wconf-flag 0))
       ((string= st "2")
	(setq wconf-flag 2))
       (t
	(venus:error
	       (format "Ŭڤʻ(%s %s)Ƥޤ" spec str)
	       venus:current-file)))
      (setq num (1+ num)))
    (if line-flag
	(progn
	  (if (or (= stdin-flag 2) (= stdin-flag 3))
	      (venus:error
	       (format "iץR,FץƱ˻Ǥޤ")
	       venus:current-file))
	  (setq cb-comfile (venus:make-temp-command str t))
	  (setq venus:current-process "*Venus:call-process*"))
      (setq cb-comfile (venus:make-temp-command (venus:get-first-arg str)))
      (setq venus:current-process (concat "*Venus:call:" 
					  (venus:get-first-arg str) "*")))
    (setq wconf (current-window-configuration))
    (set-buffer (get-buffer-create venus:current-process))
    (make-variable-buffer-local 'venus:process-name)
    (setq venus:process-name venus:current-process)
    (use-local-map venus:debug:mode-map)
    (setq major-mode 'venus:debug:mode-help)
    (setq mode-name "Venus")
    (setq buffer-read-only nil)
    (erase-buffer)
    (delete-other-windows)
    (switch-to-buffer (get-buffer venus:current-process))
    (setq default-directory venus:default-directory)
    (sit-for 0)
    (message "executing...")
    (if (= stdin-flag 0)
	(call-process cb-comfile nil
		      (get-buffer venus:current-process) nil
		      (expand-file-name venus:current-directory))
      (cond
       ((= stdin-flag 1)
	(set-buffer venus:previous-buffer))
       ((= stdin-flag 2)
	(set-buffer venus:work-buffer)
	(erase-buffer)
	(insert second))
       ((= stdin-flag 3)
	(set-buffer venus:work-buffer)
	(erase-buffer)
	(insert-file fname)))
      (call-process-region (point-min) (point-max)
			   cb-comfile
			   nil
			   (get-buffer venus:current-process)
			   nil))
    (message "executing...done")
    (if (file-exists-p cb-comfile)
	(delete-file cb-comfile))
    (cond
     ((= return-flag 0)
      (setq venus:quit-flag 2)
      (if (= wconf-flag 2)
	  (progn
	    (set-window-configuration venus:prev-win-conf)
	    (delete-other-windows)
	    (split-window)
	    (switch-to-buffer (get-buffer venus:current-process)))))
     ((= return-flag 1)
      (set-window-configuration wconf))
     ((= return-flag 2)
      (completing-read "Hit return key: " "")
      (if (= wconf-flag 0)
	  (kill-buffer (get-buffer venus:current-process)))
      (set-window-configuration wconf)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;  feature "P"

(defun venus:start-process (spec str)
  (let ((len (length spec))
	(num 1)
	(line-flag nil)
	(double-flag nil)
	sp-comfile buf proc)
    (while (< num len)
      (setq st (substring spec num (1+ num)))
      (cond
       ((string= st "i")
	(setq line-flag t))
       ((string= st "d")
	(setq venus:wconf-flag 0))
       ((string= st "P")
	(setq double-flag t))
       ((string= st "2")
	(setq venus:wconf-flag 2))
       (t
	(venus:error
	       (format "Ŭڤʻ(%s %s)Ƥޤ" spec str)
	       venus:current-file)))
      (setq num (1+ num)))
    (if double-flag
	(venus:start-process-2 str)
      (if line-flag
	  (progn
	    (setq sp-comfile (venus:make-temp-command str t))
	    (setq venus:current-process "*Venus:start-process*"))
	(setq sp-comfile (venus:make-temp-command 
			  (venus:get-first-arg str)))
	(setq venus:current-process 
	      (concat "*Venus:proc:" (venus:get-first-arg str) "*")))
      (venus:kill-buffer venus:current-process)
      (set-buffer (get-buffer-create venus:current-process))
      (make-variable-buffer-local 'venus:process-name)
      (setq venus:process-name venus:current-process)
      (setq venus:quit-flag 2)
      (if (= venus:wconf-flag 2)
	  (progn
	    (set-window-configuration venus:prev-win-conf)
	    (delete-other-windows)
	    (split-window)))
      (setq buf (get-buffer-create venus:current-process))
      (switch-to-buffer buf)
      (setq default-directory venus:default-directory)
      (if (processp (get-process venus:current-process)) 
	  (delete-process venus:current-process))
      (setq buffer-read-only nil)
      (erase-buffer)
      (sit-for 0)
      (use-local-map venus:debug:mode-map)
      (setq major-mode 'venus:debug:mode-help)
      (setq mode-name "Venus-Debug")
      (setq proc (start-process venus:process-name venus:process-name 
				sp-comfile 
				(expand-file-name  venus:current-directory)))
      (start-process "*remove-command*" nil venus:remove-command sp-comfile)
      venus:current-process
      )))
  

(defun venus:start-process-2 (str)
  (let ((str-1 (venus:get-first-arg str))
	(str-2 (venus:get-second-arg str))
	buf-1 buf-2)
    (if (not str-2)
	(venus:error
	 (format "裴बޤ")
	 venus:current-file))
    (setq buf-1 (venus:start-process "P" str-1))
    (setq buf-2 (venus:start-process "P" str-2))
    (switch-to-buffer (get-buffer buf-1))
    (delete-other-windows)
    (split-window)
    (other-window 1)
    (switch-to-buffer (get-buffer buf-2))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;  feature "S"

(defun venus:start-shell (spec str)
  (let ((len (length spec))
	(num 1)
	(double-flag nil)
	(line-flag nil)
	(shellprog (or (getenv "SHELL") "/bin/sh"))
	shellbuf ss-comfile proc)
    (while (< num len)
      (setq st (substring spec num (1+ num)))
      (cond
       ((string= st "i")
	(setq line-flag t))
       ((string= st "d")
	(setq venus:wconf-flag 0))
       ((string= st "S")
	(setq double-flag t))
       ((string= st "2")
	(setq venus:wconf-flag 2))
       (t
	(venus:error
	       (format "Ŭڤʻ(%s %s)Ƥޤ" spec str)
	       venus:current-file)))
      (setq num (1+ num)))
    (if double-flag
	(venus:start-shell-2 str)
      (if line-flag
	  (progn
	    (setq ss-comfile (venus:make-temp-command str t))
	    (setq shellbuf "Venus:start-shell")
	    (setq venus:current-process "*Venus:start-shell*"))
	(setq ss-comfile (venus:make-temp-command str))
	(setq shellbuf (concat "Venus:shell:" 
			       (venus:get-first-arg str)))
	(setq venus:current-process 
	      (concat "*Venus:shell:" (venus:get-first-arg str) "*")))
      (setq venus:quit-flag 2)
      (venus:kill-buffer venus:current-process)
;;      (make-shell shellbuf shellprog)
      (set-buffer (apply 'make-comint shellbuf (list shellprog)))
      (shell-mode)
      (switch-to-buffer (get-buffer venus:current-process))
      (setq default-directory venus:default-directory)
      (goto-char (point-max))
      (insert ss-comfile)
;;      (shell-send-input)
      (comint-send-input)
      (start-process "*remove-command*" nil venus:remove-command ss-comfile)
      venus:current-process
      )))

(defun venus:start-shell-2 (str)
  (let ((str-1 (venus:get-first-arg str))
	(str-2 (venus:get-second-arg str))
	buf-1 buf-2)
    (if (not str-2)
	(venus:error
	 (format "裴बޤ")
	 venus:current-file))
    (setq buf-1 (venus:start-shell "S" str-1))
    (setq buf-2 (venus:start-shell "S" str-2))
    (switch-to-buffer (get-buffer buf-1))
    (delete-other-windows)
    (split-window)
    (other-window 1)
    (switch-to-buffer (get-buffer buf-2))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  Venus debug mode 
;;
;; Copyright (C) 1993 Kenji KATO (kato@suri.co.jp)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


(defvar venus:debug:mode-map          nil)

(defun venus:debug:mode-help ()
  "Venus modeʥץ¹ԥХåեˤǤΥޥɡ\n\
  C-c   ץμ¹\n\
  C-i   ץʸ\n\
  SPC   顼ٹս껲\n\
   .    顼ٹսإ\n\
   n    Υ顼ٹս껲\n\
   p    Υ顼ٹս껲\n\
   q    ץХåեξõ\n\
   h    إײɽ")

(if venus:debug:mode-map
    ()
  (setq venus:debug:mode-map (make-sparse-keymap))
  (define-key venus:debug:mode-map "q"    'venus:debug:kill-process-buffer)
  (define-key venus:debug:mode-map "h"    'venus:debug:help-process-buffer)
  (define-key venus:debug:mode-map "\C-c" 'venus:debug:kill-process)
  (define-key venus:debug:mode-map "\C-i" 'venus:debug:send-process-string)
  (define-key venus:debug:mode-map " "    'venus:debug:show-error)
  (define-key venus:debug:mode-map "."    'venus:debug:goto-error)
  (define-key venus:debug:mode-map "n"    'venus:debug:next-line)
  (define-key venus:debug:mode-map "p"    'venus:debug:previous-line))


(defun venus:debug:kill-process ()
  (interactive)
  (if (string= (process-status venus:process-name) "run")
      (kill-process venus:process-name)
    (message (format "Process %s is not active" venus:process-name))))


(defun venus:debug:send-process-string ()
  (interactive)
  (if (string= (process-status venus:process-name) "run")
      (process-send-string venus:process-name
			   (concat (read-from-minibuffer "Input: " "") "\n"))
    (message (format "Process %s is not active" venus:process-name))))


(defun venus:debug:kill-process-buffer ()
  (interactive)
  (delete-other-windows)
  (kill-buffer (current-buffer)))


(defun venus:debug:help-process-buffer ()
  (interactive)
  (with-output-to-temp-buffer "*Help*" (princ (venus:debug:mode-help))))


(defun venus:debug:goto-error ()
  (interactive)
  (let (num file tp ep)
    (end-of-line)
    (setq ep (point))
    (beginning-of-line)
    (if (not (search-forward ":" ep t))
	(setq file "null")
      (backward-char)
      (setq tp (point))
      (while (and (not (bolp)) (not (= (char-after (point)) 32)))
	(backward-char))
      (if (not (bolp)) (forward-char))
      (setq file (buffer-substring tp (point)))
      (goto-char (1+ tp))
      (setq tp (point))
      (if (and (not (search-forward ":" ep t))
	       (not (search-forward "," ep t)))
	  (setq num 0)
	(backward-char)
	(setq num (string-to-int (buffer-substring tp (point))))))
    (beginning-of-line)
    (cond 
     ((not (file-exists-p (concat 
			   (expand-file-name venus:current-directory)
			   "/" file)))
      nil)
     ((= num 0) nil)
     (t
      (delete-other-windows)
      (split-window (get-buffer-window (current-buffer)) 8)
      (other-window 1)
      (find-file (concat 
		  (expand-file-name venus:current-directory) "/" file))
      (goto-line num)
      t))))


(defun venus:debug:show-error ()
  (interactive)
  (if (not (venus:debug:goto-error))
      nil
    (sit-for 1)
    (other-window 1)
    t))


(defun venus:debug:next-line ()
  (interactive)
  (next-line 1)
  (while (and (not (eobp)) (not (venus:debug:show-error)))
    (next-line 1)))


(defun venus:debug:previous-line ()
  (interactive)
  (beginning-of-line)
  (let ((pp (bobp)))
    (previous-line 1)
    (while (and (not (bobp)) (not (venus:debug:show-error)))
      (previous-line 1))
    (if (and (bobp) (not pp)) (venus:debug:show-error))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; feature "V"
;;   This is Mina program added into Venus system
;;   "mina.el V1.0" Copyright (C) 1994 Kenji KATO (kato@suri.co.jp)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun venus:mina:mode-help ()
  "Mina⡼ɤǤΥޥɡ\n\
  SPC   ǡɽ( down)\n\
  DEL   ǡɽ( up)\n\
   .    ǡƬɽ\n\
   n    Υǡɽ\n\
   p    Υǡɽ\n\
   q    λ\n\
   r    ȥǥ쥯ȥ꤫ Venus Ƽ¹\n\
   h    إײɽ")


(defun mina ()
  (interactive)
  (venus:mina (buffer-file-name (current-buffer))))


(defun venus:mina (str &optional flag)
  (let ((lnum 1)
	region tp)
    (if flag
	(setq str)
      (setq venus:current-file (concat venus:current-directory "/" str)))
    (if (not (file-exists-p venus:current-file))
	(venus:error
	 (format "ǥ쥯ȥ%s%sե뤬¸ߤޤ"
		 venus:current-directory str)
	 venus:current-file))
    (venus:mina:start)
    (set-buffer venus:mina:work-buf)
    (setq buffer-read-only nil)
    (erase-buffer)
    (insert-file venus:current-file)
    (replace-string "" "^L\n")
    (goto-char (point-min))
    (venus:get-include-list)
    (if venus:include-list
	(venus:insert-current-file))
    (setq buffer-read-only t)
    (setq region (venus:cut-region "table" venus:current-file))
    (set-buffer venus:mina:ctrl-buf)
    (setq buffer-read-only nil)
    (erase-buffer)
    (insert region)
    (untabify (point-min) (point-max))
    (goto-char (point-min))
    (setq venus:mina:list nil)
    (while (not (eobp))
      (while (= (char-after (point)) 32) (forward-char))
      (if (eolp)
	  (venus:error
	   (format "%dܤ˶Ԥޤ" lnum)
	   venus:current-file))
      (setq tp (point))
      (while (and (not (= (char-after (point)) 32))
		  (not (eolp)))
	(forward-char))
      (setq venus:mina:list
	    (cons (buffer-substring tp (point)) venus:mina:list))
      (while (= (char-after (point)) 32) (forward-char))
      (delete-region tp (point))
      (insert (format "%3d: " lnum))
      (setq lnum (1+ lnum))
      (forward-line 1))
    (setq venus:mina:list (reverse venus:mina:list))
    (setq buffer-read-only t)
    (goto-char (point-min))
    (switch-to-buffer venus:mina:ctrl-buf)
    (use-local-map venus:mina:mode-map)
    (setq mode-name "mina")
    (setq major-mode 'venus:mina:mode-help)
    (delete-other-windows)
    (split-window (get-buffer-window (current-buffer)) 8)
    (other-window 1)
    (switch-to-buffer venus:mina:show-buf)
    (setq buffer-read-only nil)
    (erase-buffer)
    (insert (venus:mina:mode-help))
    (setq buffer-read-only t)
    (other-window -1)
    (setq venus:mina:win-conf (current-window-configuration))
    (setq venus:current-file venus:current-file)
    (setq venus:mina:data (list "__nil__" "__nil__" 1))
    (venus:mina:show)
    (setq venus:quit-flag 1)))


(defun venus:mina:start ()
  (defvar venus:mina:mode-map     nil)
  (if venus:mina:mode-map
      ()
    (defvar venus:mina:list         nil)
    (defvar venus:mina:ctrl-buf     nil)
    (defvar venus:mina:show-buf     nil)
    (defvar venus:mina:work-buf     nil)
    (defvar venus:mina:win-conf     nil)
    (defvar venus:mina:data         nil)
    (setq venus:mina:mode-map (make-sparse-keymap))
    (define-key venus:mina:mode-map "q"     'venus:mina:quit)
    (define-key venus:mina:mode-map "r"     'venus:mina:retry)
    (define-key venus:mina:mode-map "h"     'venus:mina:help)
    (define-key venus:mina:mode-map " "     'venus:mina:show)
    (define-key venus:mina:mode-map "\177"  'venus:mina:previous-page)
    (define-key venus:mina:mode-map "."     'venus:mina:show-top)
    (define-key venus:mina:mode-map "n"     'venus:mina:next)
    (define-key venus:mina:mode-map "p"     'venus:mina:previous))
  (setq venus:mina:ctrl-buf (get-buffer-create "*mina:control*"))
  (setq venus:mina:show-buf (get-buffer-create "*mina:display*"))
  (setq venus:mina:work-buf (get-buffer-create "*mina:work*"))
  (buffer-flush-undo venus:mina:ctrl-buf)
  (buffer-flush-undo venus:mina:show-buf)
  (buffer-flush-undo venus:mina:work-buf)
  (venus:kill-buffer venus:buffer))


(defun venus:mina:quit () 
  (interactive)
  (venus:kill-buffer venus:buffer)
  (venus:kill-buffer venus:work-buffer)
  (venus:kill-buffer venus:mina:ctrl-buf)
  (venus:kill-buffer venus:mina:show-buf)
  (venus:kill-buffer venus:mina:work-buf)
  (delete-other-windows))


(defun venus:mina:retry ()
  (interactive)
  (venus:mina:quit)
  (venus:retry))


(defun venus:mina:help () 
  (interactive)
  (save-excursion
    (set-buffer venus:mina:show-buf)
    (setq buffer-read-only nil)
    (erase-buffer)
    (insert (venus:mina:mode-help))
    (setq buffer-read-only t)
    (setq venus:mina:data (list "__nil__" "__nil__" 1))
    ))


(defun venus:mina:show (&optional back) 
  (interactive)
  (if (eobp) (error "End of buffer"))
  (if (not (buffer-name venus:mina:work-buf))
      (error "Buffer *venus:mina:work* is killed"))
  (if (buffer-name venus:mina:show-buf) 
      ()
    (setq venus:mina:show-buf (get-buffer-create "*venus:mina:show*"))
    (buffer-flush-undo venus:mina:show-buf)
    (delete-other-windows)
    (split-window (get-buffer-window (current-buffer)) 8)
    (other-window 1)
    (switch-to-buffer venus:mina:show-buf)
    (other-window -1)
    (setq venus:mina:win-conf (current-window-configuration))
    (setq venus:mina:data (list "__nil__" "__nil__" 1)))
  (set-window-configuration venus:mina:win-conf)
  (let (lnum key reg cnum title tp np fp)
    (setq lnum (1- (count-lines (point-min) (point))))
    (if (bolp) (setq lnum (1+ lnum)))
    (setq key (nth lnum venus:mina:list))
    (if (and (string= venus:current-file (nth 0 venus:mina:data))
	     (string= key (nth 1 venus:mina:data)))
	(progn
	  (other-window 1)
	  (widen)
	  (setq tp (point))
	  (setq cnum (nth 2 venus:mina:data))
	  (if back
	      (setq cnum (- (- cnum (window-height)) 2))
	    (setq cnum (- (+ cnum (window-height)) 2)))
	  (goto-line cnum)
	  (setq np (point))
	  (goto-char tp)
	  (if back
	      (forward-page -2)
	    (forward-page 1))
	  (setq fp (point))
	  (if (if back
		  (> np fp)
		(< np fp))
	      (goto-char np)
	    (goto-char fp)
	    (setq cnum (1- (count-lines (point-min) (point))))
	    (if (bolp) (setq cnum (1+ cnum))))
	  (narrow-to-page)
	  (recenter 1)
	  (setq venus:mina:data (list venus:current-file key cnum))
	  (other-window -1))
      (setq venus:mina:data (list venus:current-file key 1))
      (set-buffer venus:mina:work-buf)
      (setq title (venus:get-item key nil venus:current-file))
      (setq reg  (venus:mina:cut-region key venus:current-file))
      (set-buffer venus:mina:show-buf)
      (setq buffer-read-only nil)
      (erase-buffer)
      (if title (insert (format "%s\n\n" title)))
      (insert reg)
      (setq buffer-read-only t)
      (goto-char (point-min))
      (narrow-to-page))
    (set-buffer venus:mina:ctrl-buf)))


(defun venus:mina:cut-region (string &optional file)
  (save-excursion
    (goto-char (point-min))
    (let ((bst (concat "@begin{" string "}"))
	  (est (concat "@end{" string "}"))
	  tp
	  retstr)
      (if (not (search-forward bst nil t))
	  (setq retstr "Not documented")
	(forward-line 1)
	(setq tp (point))
	(if (not (search-forward est nil t))
	    (setq retstr (format "%sޤ" est))
	  (beginning-of-line)
	  (setq retstr (buffer-substring tp (point)))
	  (forward-line 1)))
      retstr)))


(defun venus:mina:show-top () 
  (interactive)
  (setq venus:mina:data (list "__nil__" "__nil__" 1))
  (venus:mina:show))


(defun venus:mina:next () 
  (interactive)
  (if (eobp)
      (beep)
    (forward-line 1)
    (venus:mina:show)))


(defun venus:mina:previous () 
  (interactive)
  (if (bobp)
      (beep)
    (forward-line -1)
    (venus:mina:show)))

(defun venus:mina:previous-page ()
  (interactive)
  (venus:mina:show t))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; feature "Q"
;;   This is Usagi program merged into Venus system
;;   "usagi.el V2.0" Copyright (C) 1993 Kenji KATO (kato@suri.co.jp)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun usagi ()
  (interactive)
  (venus:usagi (buffer-file-name (current-buffer))))

(defun venus:usagi (str &optional flag)
  (interactive)
  (if flag
      (setq venus:usagi:quiz-file str)
    (setq venus:usagi:quiz-file (concat venus:current-directory "/" str)))
  (if (not (file-exists-p venus:usagi:quiz-file))
      (venus:error
       (format "ǥ쥯ȥ%s%sե뤬¸ߤޤ"
	       venus:current-directory str)
       venus:usagi:quiz-file))
  (venus:usagi:start)
  (while (and (not venus:usagi:flag-quit)
	      (<= venus:usagi:curr-qnum venus:usagi:total-qnum))
    (venus:usagi:get-curr-question)
    (venus:usagi:print-question-buffer)
    (venus:usagi:print-answer-buffer)
    (venus:usagi:print-status-buffer)
    (venus:usagi:question-and-update))
  (if (not venus:usagi:flag-quit) (venus:usagi:show-result))
  (venus:usagi:finish))


(defun venus:usagi:start ()
  (venus:usagi:init)
  (setq venus:quit-flag 2)
  (setq venus:usagi:prev-win-conf venus:prev-win-conf)
  (venus:usagi:set-vector)
  (switch-to-buffer (get-buffer-create
		     (aref venus:usagi:vect-others 2)))
  (buffer-flush-undo (get-buffer
		      (aref venus:usagi:vect-others 2)))
  (venus:usagi:set-usagi-win-conf)
  (venus:usagi:set-quiz-information)
  (get-buffer-create (aref venus:usagi:vect-others 2))
  (setq venus:usagi:curr-buffer venus:buffer))


(defun venus:usagi:init ()
  (defvar venus:usagi:mode-map          nil) ; ⡼ɥޥå
  (if venus:usagi:mode-map
      ()
    (setq venus:usagi:mode-map (make-sparse-keymap))
    (define-key venus:usagi:mode-map "q" 'venus:usagi:quit)
    (define-key venus:usagi:mode-map "r" 'venus:usagi:retry)
    (define-key venus:usagi:mode-map "h" 'venus:usagi:help)
    (define-key venus:usagi:mode-map "." 'venus:usagi:show)
    (define-key venus:usagi:mode-map " " 'venus:usagi:show)
    (define-key venus:usagi:mode-map "n" 'venus:usagi:next-line)
    (define-key venus:usagi:mode-map "p" 'venus:usagi:previous-line)
    (define-key venus:usagi:mode-map ">" 'venus:usagi:write-to-file)

;    (defvar   venus:usagi:language    "japanese")
    (defvar   venus:usagi:language    "english")
    (defvar   venus:usagi:dir         nil)
    (defvar   venus:usagi:vect-keyword nil)
    (defvar   venus:usagi:vect-others nil)
    (defvar   venus:usagi:vect-errmsg nil)
    (defvar   venus:usagi:vect-message nil)
    (defvar venus:usagi:curr-buffer       nil) ; 
    (defvar venus:usagi:prev-buffer       nil) ; 
    (defvar venus:usagi:work-buffer       nil) ; 
    (defvar venus:usagi:win-conf          nil) ; winconf
    (defvar venus:usagi:prev-win-conf     nil) ; winconf
    (defvar venus:usagi:quiz-file         nil) ; ե
    (defvar venus:usagi:curr-theme        nil) ; ߤΥ
    (defvar venus:usagi:curr-dir          nil) ; ߤΥǥ쥯ȥ
    (defvar venus:usagi:curr-qnum         nil) ; ߤֹ
    (defvar venus:usagi:curr-points       nil) ; ߤ
    (defvar venus:usagi:curr-max          nil) ; ߤҿ
    (defvar venus:usagi:curr-truth        nil) ; ߤֹ
    (defvar venus:usagi:curr-rank         nil) ; ߤ
    (defvar venus:usagi:curr-author       nil) ; ߤκ
    (defvar venus:usagi:curr-total-points nil) ; ߤޤǤι
    (defvar venus:usagi:your-curr-qnum    nil) ; ߤޤ򤷤
    (defvar venus:usagi:your-curr-points  nil) ; ߤޤǤ
    (defvar venus:usagi:total-qnum        nil) ; 
    (defvar venus:usagi:total-points      nil) ; 
    (defvar venus:usagi:flag-quit         nil) ; 潪λե饰
    (defvar venus:usagi:flag-retry-cdir   nil) ; Ƽ¹ԥե饰
    (defvar venus:usagi:flag-correct      nil) ; ե饰
    (defvar venus:usagi:list-flag-correct nil) ; 򤷤ɤΥꥹ
    (defvar venus:usagi:list-contents     nil) ; եƤΥꥹ
    (defvar venus:usagi:list-rank         nil) ; ٤Υꥹ
    (defvar venus:usagi:list-points       nil) ; Υꥹ
    (defvar venus:usagi:list-author       nil) ; ԤΥꥹ
    (defvar venus:usagi:fill-column       nil) ; fill-column
    (defvar venus:usagi:top-dir           nil) ; ȥåץǥ쥯ȥ
    ))


(defun venus:usagi:set-vector ()
  (setq venus:usagi:vect-keyword 
	["title"     "title"     "opening"   "ending"    "points" ; 0 -  4
	 "menu"      "table"     "quiz"      "author"    "rank"   ; 4 -  9
	 "question"  "choice"    "answer"    ])                   ;10 - 12
  (if (string= venus:usagi:language "japanese")
      (setq venus:usagi:vect-errmsg 
	    [
	   "venus:usagi:dir(%s)ְ꤬äƤޤ"             ; 0
	   "@%s } Ĥޤ"                          ; 1
           "%dԤб%sޤ"                    ; 2
           "%dԤ%sƤޤ"              ; 3
	   "ե롧%s\n\n"                                  ; 4
           "USAGIե뤬¸ߤޤ"                       ; 5
           "%sȤեϥǥ쥯ȥ¸ߤޤ"  ; 6
	   "%sޤ"                                  ; 7
	  ])
    (setq venus:usagi:vect-errmsg
	  [
	   "venus:usagi:dir(%s) does not exist"                      ; 0
	   "Missing } in @%s"                                  ; 1
           "Line number %d: %s not found"                      ; 2
           "Line number %d: %s not defined"                    ; 3
	   "File: %s\n\n"                                      ; 9
           "USAGI file does not exist"                         ; 5
           "File or directory %s does not exist"               ; 6
	   "%s not found"                                      ; 7
	  ]))

  (if (string= venus:usagi:language "japanese")
      (setq venus:usagi:vect-message
	  [
;;; 0
"\
裲(94/2/27)\n\
  author: Kenji Kato\n\
  q(λ)r(Ƽ¹)\n\
\n"
;;; 1
  "\
⡼ɤǤϰʲΥޥɤѤǤޤ\n\
\n\
   .    Ȳɽ\n\
   SPC  Ȳɽ\n\
   n    Ȳɽ\n\
   p    Ȳɽ\n\
   >    ե¸\n\
   q    λ\n\
   r    ȥǥ쥯ȥ꤫ʥκƼ¹\n\
   h    إ\n"
;;; 2
"\n\"q\"ǽλ \"..\"Ǿ̲̤ء\"r\"ǺǾ̲̤\n\
\"t\"ǥȥåץǥ쥯ȥѹ"
;;; 3
"\
ɾ%s\n\
 Ψ	%3d/%3d(%d%%)\n\
%3d/%3d(%d%%)\n\
\n"
;;; 4
"\
ֹ樢  %3d(/%3d)\n\
  %3d(/%3d)\n\
  %s\n\
 	%s"
;;; 5
"\
ɾ%s\n\
 Ψ	%3d/%3d(%d%%)\n\
    %3d/%3d(%d%%)\n\
\n\
\n\
ϽǤ"
;;; 6
"\
 ̾ %s\n\
 Ψ	%3d/%3d(%d%%)\n\
    %3d/%3d(%d%%)\n\
\n\n"
;;; 7
"  0 --   rank       ʼ¹Է̤ɾɽ\n"
          ])
;;; ---
    (setq venus:usagi:vect-message
	  [
;;; 0
"\
Usagi ver2(27/Feb/94)\n\
  author: Kenji Kato\n\
  q(Quit), r(Retry)\n\
--------+--------------\n"
;;; 1
  "\
Following commands are available in Usagi-mode\n\
   .    show current question and answer\n\
   SPC  show current question and answer\n\
   n    show next question and answer\n\
   p    show previous question and answer\n\
   >    save to file\n\
   q    quit\n\
   r    retry venus from current directory\n\
   h    help\n"
;;; 2
"\n\"q\" quit, \"..\" upper menu, \"r\" top menu\n\"t\" change top directory"
;;; 3
"\
 correct| %s\n\
 ratio  | %3d/%3d(%d%%)\n\
 score  | %3d/%3d(%d%%)\n\
--------+--------------\n"
;;; 4
"\
  No.   | %3d(/%3d)\n\
 points | %3d(/%3d)\n\
  rank  | %s\n\
 author | %s"
;;; 5
"\
 correct| %s\n\
 ratio  | %3d/%3d(%d%%)\n\
 score  | %3d/%3d(%d%%)\n\
--------+--------------\n
\n\
 End of the quiz"
;;; 6
"\
  title | %s\n\
  ratio | %3d/%3d(%d%%)\n\
  score | %3d/%3d(%d%%)\n\
--------+-------------------------------------\n\n"
;;; 7
"  0 -- pts rank   author    (evaluation)\n"
      ]))

  (if (string= venus:usagi:language "japanese")
      (setq venus:usagi:vect-others
	  ["*:*"     "*:*"   "*:*"  ;  0 -  2
	   "*:ե*" "*:ɽ*"   "*:*"  ;  3 -  5
	   "*:顼*"   ""	         "----"           ;  6 -  8
	   "10"  	       "̤"          "˥塼"       ;  9 - 11
           ""              ""  	 ""             ; 12 - 14
	   ""  	       ""          ""           ; 15 - 17
	   ])
    (setq venus:usagi:vect-others
	  ["*Usagi:status*"    "*Usagi:answer*"	 "*Usagi:quiz*"    ;  0 -  2
	   "*Usagi:file*"      "*Usagi:display*" "*Usagi:control*" ;  3 -  5
	   "*Usagi:error*"     "Usagi"	         "----"	           ;  6 -  8
	   "10"	               "undefined" 	 "menu"	           ;  9 - 11
           "question"          "choice"	         "OK"		   ; 12 - 14
	   "NO"	               "Usagi"           "answer"	   ; 15 - 17
	    ]))
)


(defun venus:usagi:set-quiz-information ()
  (setq venus:usagi:flag-correct nil)
  (setq venus:usagi:flag-quit nil)
  (setq venus:usagi:curr-qnum 1)
  (setq venus:usagi:curr-total-points 0)
  (setq venus:usagi:your-curr-qnum 0)
  (setq venus:usagi:your-curr-points 0)
  (setq venus:usagi:total-qnum 0)
  (setq venus:usagi:total-points 0)
  (buffer-flush-undo (set-buffer (get-buffer-create (aref venus:usagi:vect-others 3))))
  (let (tp bp ep
	   (bpro (concat "@begin{" 
			 (aref venus:usagi:vect-keyword 7)
			 "}"))
	   (epro (concat "@end{"
			 (aref venus:usagi:vect-keyword 7)
			 "}")))
    (setq buffer-read-only nil)
    (erase-buffer)
    (insert-file venus:usagi:quiz-file)
    (setq buffer-read-only t)
    (setq venus:usagi:curr-theme 
	  (venus:usagi:get-item (aref venus:usagi:vect-keyword 1)
			  (aref venus:usagi:vect-others 10)
			  venus:usagi:quiz-file))
    (venus:usagi:cut-region (aref venus:usagi:vect-keyword 2)
		      venus:usagi:quiz-file)
    (goto-char (point-min))
    (venus:usagi:cut-region (aref venus:usagi:vect-keyword 3) 
		      venus:usagi:quiz-file)
    (goto-char (point-min))
    (if (search-forward bpro nil t)
	(progn
	  (beginning-of-line)
	  (setq bp (point)))
      (venus:usagi:error (format (aref venus:usagi:vect-errmsg 7)
			   bpro)
		   venus:usagi:quiz-file))
    (if (search-backward epro nil t)
	(venus:usagi:error (format (aref venus:usagi:vect-errmsg 2)
			     (1+ (count-lines (point-min) (point)))
			     bpro)
		     venus:usagi:quiz-file))
    (goto-char bp)
    (setq ep (point-max))
    (while (search-forward bpro nil t)
      (setq venus:usagi:total-qnum (1+ venus:usagi:total-qnum))
      (beginning-of-line)
      (setq bp (point))
      (if (< ep bp)
	  (venus:usagi:error (format (aref venus:usagi:vect-errmsg 2)
			       (1+ (count-lines (point-min) ep))
			       bpro)
		       venus:usagi:quiz-file))
      (if (not (search-forward epro nil t))
	  (venus:usagi:error (format (aref venus:usagi:vect-errmsg 2)
			       (1+ (count-lines (point-min) bp))
			       epro)
		       venus:usagi:quiz-file))
      (beginning-of-line)
      (setq ep (point))
      (search-backward bpro)
      (beginning-of-line)
      (if (not (= bp (point)))
	  (venus:usagi:error (format (aref venus:usagi:vect-errmsg 2)
			       (1+ (count-lines (point-min) bp))
				epro)
		       venus:usagi:quiz-file))
      (if (not (search-forward (concat "@" 
				       (aref venus:usagi:vect-keyword 4)
				       "{")
			       nil t))
	  (venus:usagi:error (format (aref venus:usagi:vect-errmsg 3)
			       (1+ (count-lines (point-min) bp))
			       (aref venus:usagi:vect-keyword 4))
		       venus:usagi:quiz-file))
      (beginning-of-line)
      (if (< ep (point))
	  (venus:usagi:error (format (aref venus:usagi:vect-errmsg 3)
			       (1+ (count-lines (point-min) bp))
			       (aref venus:usagi:vect-keyword 4))
		       venus:usagi:quiz-file))
      (setq venus:usagi:total-points 
	    (+ venus:usagi:total-points
	       (string-to-int
		(venus:usagi:get-item 
		 (aref venus:usagi:vect-keyword 4)
		 (aref venus:usagi:vect-others 9)
		 venus:usagi:quiz-file)))) 
      (goto-char ep)
      (setq tp ep)
      (forward-line 1)
      (if (search-forward epro nil t)
	  (progn
	    (beginning-of-line)
	    (setq ep (point)))
	(setq ep (point-max)))
      (goto-char tp))
    (end-of-line)
    (if (search-forward epro nil t)
	(venus:usagi:error (format (aref venus:usagi:vect-errmsg 2)
			     (count-lines (point-min) (point))
			     bpro)
		     venus:usagi:quiz-file))
    (goto-char (point-min))))



(defun venus:usagi:set-usagi-win-conf ()
  (setq venus:usagi:curr-buffer (aref venus:usagi:vect-others 4))
  (setq venus:usagi:prev-buffer (aref venus:usagi:vect-others 5))
  (switch-to-buffer (get-buffer-create (aref venus:usagi:vect-others 0)))
  (buffer-flush-undo (get-buffer (aref venus:usagi:vect-others 0)))
  (delete-other-windows)
  (setq venus:usagi:fill-column (- (window-width) 6))
  (split-window-vertically 9)
  (split-window-horizontally 26)
  (other-window 1)
  (switch-to-buffer (get-buffer-create (aref venus:usagi:vect-others 1)))
  (buffer-flush-undo (get-buffer (aref venus:usagi:vect-others 1)))
  (other-window 1)
  (switch-to-buffer (get-buffer (aref venus:usagi:vect-others 2)))
  (setq venus:usagi:win-conf (current-window-configuration))
  (buffer-flush-undo (get-buffer-create venus:usagi:curr-buffer))
  (buffer-flush-undo (get-buffer-create venus:usagi:prev-buffer)))


(defun venus:usagi:get-curr-question ()
  (let (tp prob)
    (set-buffer (get-buffer (aref venus:usagi:vect-others 3)))
    (setq prob (venus:usagi:cut-region 
		(aref venus:usagi:vect-keyword 7)
		venus:usagi:quiz-file))
    (set-buffer (get-buffer venus:usagi:curr-buffer))
    (setq buffer-read-only nil)
    (erase-buffer)
    (insert prob)
    (goto-char (point-min))))


(defun venus:usagi:question-and-update ()
  (let (ansnum answer)
    (setq answer (completing-read "which? " ""))
    (setq ansnum (string-to-int answer))
    (while (and
	    (not (string= answer "q"))
	    (not (string= answer "r"))
	    (or (<= ansnum 0) (> ansnum venus:usagi:curr-max)))
      (setq answer (completing-read "which? " ""))
      (setq ansnum (string-to-int answer)))
    (if (string= answer "q") (setq venus:usagi:flag-quit t))
    (if (string= answer "r")
	(progn
	  (setq venus:usagi:flag-quit t)
	  (setq venus:usagi:flag-retry-cdir t)))
    (setq venus:usagi:curr-qnum (1+ venus:usagi:curr-qnum))
    (setq venus:usagi:curr-total-points (+ venus:usagi:curr-total-points venus:usagi:curr-points))
    (if (= ansnum venus:usagi:curr-truth) 
	(progn
	  (setq venus:usagi:flag-correct t)
	  (setq venus:usagi:your-curr-qnum (1+ venus:usagi:your-curr-qnum))
	  (setq venus:usagi:your-curr-points (+ venus:usagi:your-curr-points venus:usagi:curr-points)))
      (setq venus:usagi:flag-correct nil))
    (setq venus:usagi:list-flag-correct 
	  (cons venus:usagi:flag-correct venus:usagi:list-flag-correct))
    (set-buffer (get-buffer venus:usagi:prev-buffer))
    (setq buffer-read-only nil)
    (erase-buffer)
    (insert-buffer (get-buffer venus:usagi:curr-buffer))))


(defun venus:usagi:print-question-buffer ()
  (let ((fill-column venus:usagi:fill-column)
	prob select tp num)
    (set-buffer (get-buffer venus:usagi:curr-buffer))
    (goto-char (point-min))
    (setq venus:usagi:curr-author 
	  (venus:usagi:get-item (aref venus:usagi:vect-keyword 8)
			  (aref venus:usagi:vect-others 7)
			  venus:usagi:quiz-file))
    (setq venus:usagi:curr-rank
	  (venus:usagi:get-item (aref venus:usagi:vect-keyword 9)
			  (aref venus:usagi:vect-others 8)
			  venus:usagi:quiz-file))
    (setq venus:usagi:curr-points 
	  (string-to-int 
	   (venus:usagi:get-item (aref venus:usagi:vect-keyword 4)
			   (aref venus:usagi:vect-others 9)
			   venus:usagi:quiz-file)))
    (setq prob (venus:usagi:cut-region 
		(aref venus:usagi:vect-keyword 10) 
		venus:usagi:quiz-file))
    (goto-char (point-min))
    (setq select (venus:usagi:cut-region 
		  (aref venus:usagi:vect-keyword 11) 
		  venus:usagi:quiz-file))
    (set-buffer (get-buffer (aref venus:usagi:vect-others 2)))
    (erase-buffer)
    (insert   "****** " (aref venus:usagi:vect-others 12) " ******\n")
    (setq tp (point))
    (insert prob)
    (fill-region tp (point-max))
    (setq venus:usagi:list-contents
	  (cons 
	   (venus:usagi:cut-string (buffer-substring tp (min 80 (point))) 70)
	   venus:usagi:list-contents))
    (setq num 0)
    (insert "\n****** " (aref venus:usagi:vect-others 13) " ******\n")
    (save-excursion (insert select))
    (while (search-forward "@" nil t)
      (if (= (char-after (point)) 33) ;!
	  (progn
	    (setq num (1+ num))
	    (delete-region (1- (point)) (1+ (point)))
	    (insert (format "%2d: " num)))
	(if (= (char-after (point)) 36) ;$
	    (progn
	      (setq num (1+ num))
	      (delete-region (1- (point)) (1+ (point)))
	      (insert (format "%2d: " num))
	      (setq venus:usagi:curr-truth num)))))
    (setq venus:usagi:curr-max num)
    (setq venus:usagi:list-rank
	  (cons venus:usagi:curr-rank venus:usagi:list-rank))
    (setq venus:usagi:list-author
	  (cons venus:usagi:curr-author venus:usagi:list-author))
    (setq venus:usagi:list-points
	  (cons venus:usagi:curr-points venus:usagi:list-points))
    (goto-char (point-min))))



(defun venus:usagi:print-status-buffer ()
  (set-buffer (get-buffer (aref venus:usagi:vect-others 0)))
  (erase-buffer)
  (if (= venus:usagi:curr-qnum 1)
      (insert (aref venus:usagi:vect-message 0))
    (insert (format (aref venus:usagi:vect-message 3)
		    (venus:usagi:center-line 
		     (aref venus:usagi:vect-others (if venus:usagi:flag-correct 14 15)) 14)
		    venus:usagi:your-curr-qnum
		    (1- venus:usagi:curr-qnum)
		    (/ (* venus:usagi:your-curr-qnum 100) (1- venus:usagi:curr-qnum))
		    venus:usagi:your-curr-points
		    venus:usagi:curr-total-points
		    (/ (* venus:usagi:your-curr-points 100) venus:usagi:curr-total-points))))
    (insert (format (aref venus:usagi:vect-message 4)
		    venus:usagi:curr-qnum
		    venus:usagi:total-qnum
		    venus:usagi:curr-points
		    venus:usagi:total-points
		    (venus:usagi:center-line venus:usagi:curr-rank 14)
		    (venus:usagi:center-line venus:usagi:curr-author 14))))


(defun venus:usagi:center-line (str len)
  (let ((retstr str)
	(tmp (/ (- len (length str)) 2)))
    (while (> tmp 0)
      (setq retstr (concat " " retstr " "))
      (setq tmp (1- tmp)))
    retstr))


(defun venus:usagi:print-last-display-buffer ()
  (set-buffer (get-buffer (aref venus:usagi:vect-others 0)))
  (erase-buffer)
  (insert (format (aref venus:usagi:vect-message 5)
		  (venus:usagi:center-line 
		   (aref venus:usagi:vect-others (if venus:usagi:flag-correct 14 15)) 14)
		  venus:usagi:your-curr-qnum
		  (1- venus:usagi:curr-qnum)
		  (/ (* venus:usagi:your-curr-qnum 100) (1- venus:usagi:curr-qnum))
		  venus:usagi:your-curr-points
		  venus:usagi:curr-total-points
		  (/ (* venus:usagi:your-curr-points 100) venus:usagi:curr-total-points))))


(defun venus:usagi:print-answer-buffer () 
  (let (answer)
    (if (= venus:usagi:curr-qnum 1)
	(progn
	  (set-buffer (get-buffer (aref venus:usagi:vect-others 3)))
	  (save-excursion
	    (goto-char (point-min))
	    (setq answer (venus:usagi:cut-region 
			  (aref venus:usagi:vect-keyword 2)
			  venus:usagi:quiz-file))))
      (set-buffer (get-buffer venus:usagi:prev-buffer))
      (goto-char (point-min))
      (setq answer (venus:usagi:cut-region
		    (aref venus:usagi:vect-keyword 12)
		    venus:usagi:quiz-file)))
    (set-buffer (get-buffer (aref venus:usagi:vect-others 1)))
    (erase-buffer)
    (insert answer))
  (goto-char (point-min))
  (let ((fill-column (- venus:usagi:fill-column 26)))
    (fill-region (point-min) (point-max))))

  
(defun venus:usagi:show-result ()
  (beep)
  (venus:usagi:print-last-display-buffer)
  (venus:usagi:print-answer-buffer)
  (let (ending)
    (set-buffer (get-buffer (aref venus:usagi:vect-others 3)))
    (goto-char (point-min))
    (setq ending (venus:usagi:cut-region
		  (aref venus:usagi:vect-keyword 3) 
		  venus:usagi:quiz-file))
    (set-buffer (get-buffer (aref venus:usagi:vect-others 2)))
    (erase-buffer)
    (insert ending))
  (completing-read "Hit Return Key:" ""))


(defun venus:usagi:finish ()
  (if venus:usagi:flag-quit 
      (progn
	(venus:usagi:kill-buffers 
	 (list (aref venus:usagi:vect-others 0)
	       (aref venus:usagi:vect-others 1)
	       (aref venus:usagi:vect-others 2)
	       (aref venus:usagi:vect-others 3)
	       (aref venus:usagi:vect-others 5)
	       (aref venus:usagi:vect-others 6)
	       (aref venus:usagi:vect-others 4)))
	(if venus:usagi:flag-retry-cdir
	    (venus:retry)
	  (set-window-configuration venus:usagi:prev-win-conf)
	  (setq venus:usagi:prev-win-conf nil)))
    (venus:usagi:kill-buffers 
     (list (aref venus:usagi:vect-others 0)
	   (aref venus:usagi:vect-others 6)
	   (aref venus:usagi:vect-others 2)))
    (setq venus:usagi:work-buffer (aref venus:usagi:vect-others 1))
    (venus:usagi:control-result)))


(defun venus:usagi:control-result ()
  (delete-other-windows)
  (switch-to-buffer (get-buffer-create (aref venus:usagi:vect-others 5)))
  (buffer-flush-undo (get-buffer (aref venus:usagi:vect-others 5)))
  (venus:usagi:set-usagi-mode)
  (split-window-vertically 6)
  (other-window 1)
  (switch-to-buffer (get-buffer-create (aref venus:usagi:vect-others 4)))
  (buffer-flush-undo (get-buffer (aref venus:usagi:vect-others 4)))
  (other-window 1)
  (setq venus:usagi:win-conf (current-window-configuration))
  (venus:usagi:help))


(defun venus:usagi:set-usagi-mode ()
  (setq mode-name (aref venus:usagi:vect-others 16))
  (setq major-mode 'venus:usagi:mode-help)
  (use-local-map venus:usagi:mode-map)
  (setq buffer-read-only nil)
  (erase-buffer)
  (insert (aref venus:usagi:vect-message 7))
  (let ((fill-column venus:usagi:fill-column)
	(tnum 1)
	curr
	tp)
    (setq tnum 1)
    (set-buffer (get-buffer (aref venus:usagi:vect-others 5)))
    (while (< tnum (1+ venus:usagi:total-qnum))
      (setq curr (- venus:usagi:total-qnum tnum))
      (insert 
       (format "%3d %2s %3s %4s %10s  " 
	       tnum
	       (aref venus:usagi:vect-others 
		     (if (nth curr venus:usagi:list-flag-correct) 14 15))
	       (venus:usagi:cut-string
		(int-to-string (nth curr venus:usagi:list-points)) 3)
	       (venus:usagi:center-line
		(venus:usagi:cut-string (nth curr venus:usagi:list-rank) 4) 4)
	       (venus:usagi:center-line
		(venus:usagi:cut-string (nth curr venus:usagi:list-author) 12) 12)))
      (setq tp (point))
      (insert (nth curr venus:usagi:list-contents))
      (fill-region tp (point-max))
      (goto-line (+ tnum 2))
      (delete-region (point) (point-max))
      (setq tnum (1+ tnum))))
  (goto-char (point-min))
  (setq buffer-read-only t))


(defun venus:usagi:cut-string (string len)
  (let ((strlen (length string))
	ch)
    (if (< strlen len)
	string
      (substring string 0 len))))


(defun venus:usagi:quit ()
  (interactive)
  (setq venus:usagi:list-flag-correct nil)
  (setq venus:usagi:list-contents nil)
  (setq venus:usagi:list-rank nil)
  (setq venus:usagi:list-points nil)
  (setq venus:usagi:list-author nil)
  (venus:usagi:kill-buffers 
   (list (aref venus:usagi:vect-others 3)
	 (aref venus:usagi:vect-others 5)
	 (aref venus:usagi:vect-others 6)
	 (aref venus:usagi:vect-others 4)
	 venus:usagi:work-buffer))
  (set-window-configuration venus:usagi:prev-win-conf))


(defun venus:usagi:retry ()
  (interactive)
  (venus:usagi:quit)
  (venus:retry))

(defun venus:usagi:mode-help ()
  (aref venus:usagi:vect-message 1))

(defun venus:usagi:help ()
  (interactive)
  (set-buffer (get-buffer (aref venus:usagi:vect-others 5)))
  (set-window-configuration venus:usagi:win-conf)
  (other-window 1)
  (switch-to-buffer (get-buffer-create (aref venus:usagi:vect-others 4)))
  (erase-buffer)
  (insert (venus:usagi:mode-help))
  (other-window 1))


(defun venus:usagi:write-to-file (filename)
  (interactive "FWrite file: ")
  (venus:usagi:show)
  (set-buffer (get-buffer-create (aref venus:usagi:vect-others 4)))
  (write-file filename)
  (set-buffer (get-buffer (aref venus:usagi:vect-others 5)))
  (save-excursion
    (beginning-of-line)
    (forward-char 3)
    (setq buffer-read-only nil)
    (delete-char 1)
    (insert ">")
    (setq buffer-read-only t))
  (set-window-configuration venus:usagi:win-conf))


(defun venus:usagi:insert-result ()
  (let (ending)
    (set-buffer (get-buffer (aref venus:usagi:vect-others 3)))
    (goto-char (point-min))
    (setq ending (venus:usagi:cut-region 
		  (aref venus:usagi:vect-keyword 3)
		  venus:usagi:quiz-file))
    (set-buffer (get-buffer-create (aref venus:usagi:vect-others 4)))
    (erase-buffer)
    (insert (format (aref venus:usagi:vect-message 6)
		    venus:usagi:curr-theme
		    venus:usagi:your-curr-qnum
		    (1- venus:usagi:curr-qnum)
		    (/ (* venus:usagi:your-curr-qnum 100) (1- venus:usagi:curr-qnum))
		    venus:usagi:your-curr-points
		    venus:usagi:curr-total-points
		    (/ (* venus:usagi:your-curr-points 100) venus:usagi:curr-total-points)))
    (insert ending)
    (set-window-configuration venus:usagi:win-conf)
    (other-window 1)
    (switch-to-buffer (get-buffer (aref venus:usagi:vect-others 4)))
    (other-window 1)))


(defun venus:usagi:next-line ()
  (interactive)
  (if (eobp)
      (beep)
    (forward-line 1)
    (venus:usagi:show)))

(defun venus:usagi:previous-line ()
  (interactive)
  (if (bobp)
      (beep)
    (forward-line -1)
    (venus:usagi:show)))


(defun venus:usagi:show ()
  (interactive)
  (let ((fill-column venus:usagi:fill-column)
	qnum prob ques sel ans tp inum)
    (setq qnum (1- (count-lines (point-min) (point))))
    (if (bolp) (setq qnum (1+ qnum)))
    (cond
     ((= qnum 0)
      (venus:usagi:insert-result))
     ((> qnum venus:usagi:total-qnum)
      nil)
     (t
      (set-buffer (get-buffer (aref venus:usagi:vect-others 3)))
      (goto-char (point-min))
      (while (> qnum 0)
	(search-forward (concat "@begin{" 
				(aref venus:usagi:vect-keyword 7)
				"}"))
	(setq qnum (1- qnum)))
      (beginning-of-line)
      (setq prob (venus:usagi:cut-region 
		  (aref venus:usagi:vect-keyword 7)
		  venus:usagi:quiz-file))
      (set-buffer (get-buffer-create venus:usagi:work-buffer))
      (erase-buffer)
      (insert prob)
      (goto-char (point-min))
      (setq ques (venus:usagi:cut-region 
		  (aref venus:usagi:vect-keyword 10) 
		  venus:usagi:quiz-file))
      (goto-char (point-min))
      (setq sel (venus:usagi:cut-region
		 (aref venus:usagi:vect-keyword 11)
		 venus:usagi:quiz-file))
      (goto-char (point-min))
      (setq ans (venus:usagi:cut-region 
		 (aref venus:usagi:vect-keyword 12) 
		 venus:usagi:quiz-file))
      (set-buffer (get-buffer-create (aref venus:usagi:vect-others 4)))
      (erase-buffer)
      (insert   "****** " (aref venus:usagi:vect-others 12) " ******\n")
      (setq tp (point))
      (insert ques)
      (fill-region tp (point-max))
      (insert "\n****** " (aref venus:usagi:vect-others 13) " ******\n")
      (setq tp (point))
      (insert sel)
      (goto-char tp)
      (setq inum 0)
      (while (search-forward "@" nil t)
	(if (= (char-after (point)) 33) ;!
	    (progn
	      (setq inum (1+ inum))
	      (delete-region (1- (point)) (1+ (point)))
	      (insert (format "%2d: " inum)))
	  (if (= (char-after (point)) 36) ;$
	      (progn
		(setq inum (1+ inum))
		(delete-region (1- (point)) (1+ (point)))
		(insert (format "%2d: " inum))))))
      (goto-char (point-max))
      (insert "\n****** " (aref venus:usagi:vect-others 17) " ******\n")
      (setq tp (point))
      (insert ans)
      (fill-region tp (point-max))
      (set-buffer (get-buffer (aref venus:usagi:vect-others 5)))
      (set-window-configuration venus:usagi:win-conf)
      (other-window 1)
      (switch-to-buffer (get-buffer (aref venus:usagi:vect-others 4)))
      (other-window 1)))))


(defun venus:usagi:error (fmt file)
  (setq venus:usagi:flag-quit nil)
  (setq venus:usagi:flag-retry-cdir nil)
  (venus:usagi:kill-buffers 
   (list (aref venus:usagi:vect-others 0)
	 (aref venus:usagi:vect-others 1)
	 (aref venus:usagi:vect-others 2)
	 (aref venus:usagi:vect-others 3)
	 (aref venus:usagi:vect-others 5)
	 (aref venus:usagi:vect-others 4)))
  (delete-other-windows)
  (switch-to-buffer (get-buffer-create (aref venus:usagi:vect-others 6)))
  (buffer-flush-undo (get-buffer (aref venus:usagi:vect-others 6)))
  (erase-buffer)
  (insert (format (aref venus:usagi:vect-errmsg 4) file))
  (insert fmt)
  (goto-char (point-min))
  (error "error"))


(defun venus:usagi:cut-region (string file)
  (let ((bst (concat "@begin{" string "}"))
	(est (concat "@end{" string "}"))
	tp
	retstr)
    (if (search-forward bst nil t)
	(progn
	  (forward-line 1)
	  (setq tp (point))
	  (if (search-forward est nil t)
	      (progn
		(beginning-of-line)
		(setq retstr (buffer-substring tp (point)))
		(forward-line 1))
	    (venus:usagi:error
		   (format (aref venus:usagi:vect-errmsg 7)
			   est) 
		   file)))
      (venus:usagi:error (format (aref venus:usagi:vect-errmsg 7)
			   bst) 
		   file))
    retstr))
  

(defun venus:usagi:get-item (item default file)
  (save-excursion
    (if (search-forward (concat "@" item "{") nil t)
	(let ((tp (point)) ep)
	  (end-of-line)
	  (setq ep (point))
	  (goto-char tp)
	  (if (search-forward "}" ep t)
	      (if (= tp (1- (point)))
		  default
		(buffer-substring tp (1- (point))))
	    (venus:usagi:error (format 
			  (aref venus:usagi:vect-errmsg 1)
			  item)
		   file)))
	default)))


(defun venus:usagi:kill-buffers (list)
  (let (tb)
    (while list
      (setq tb (get-buffer (car list)))
      (if (and tb (bufferp tb))
	  (kill-buffer tb))
      (setq list (cdr list)))))
